#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

class SidfmdQueueDist < ActiveRecord::Base
  belongs_to :sidfmd_queue

  scope :enable_hosts, -> { joins(:sidfmd_queue).where(:sidfmd_queues => { :sidfmd_host_id => SidfmdHost.enable_hosts.categorized.select(:id) }) }

  # 有効なホストのident, version, nameversionを取得可能。
  def self.get_dist_versions
    self.enable_hosts.select('ident,version,CONCAT(CONCAT(name,\' \'),version) AS nameversion').distinct('nameversion')
  end

  # OS毎の分布を返す
  # FIXME: 今のところAgent経由のみ
  def self.distribution_host(category_id = 0)
    distversions = SidfmdHost.enable_hosts.categorized
    if category_id > 0 then
      distversions = distversions.joins(:sidfmd_categories_hosts).where(:sidfmd_categories_hosts => { :sidfmd_category_id => category_id })
    end
    distversions = distversions.select(:id,'(SELECT CONCAT(name,\' \',version) FROM sidfmd_queue_dists WHERE sidfmd_queue_id=(SELECT id FROM sidfmd_queues WHERE sidfmd_host_id=sidfmd_hosts.id ORDER BY created_at DESC LIMIT 1) ORDER BY created_at DESC LIMIT 1) AS distversion')
    ret = {}
    distversions.each do |distversion|
      if ret.has_key?(distversion[:distversion]) then
        ret[distversion[:distversion]] += 1
      else
        ret[distversion[:distversion]] = 1
      end
    end
    ret
  end

  def get_nameversion
    "#{name} #{version}"
  end

end
