/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

/* ホスト管理画面の処理 */

// 選択されたアプリケーションを出力する。
function select_item_append(pid, name, vid, fullname, prefix = '') {
    var selected_item = $('<a></a>', {
	class: 'btn btn-light-nb mb-1 mr-1',
	href: '#',
	onclick: 'deselect_item(' + pid + ',' + vid + ",'" + prefix + "')",
	text: fullname.length > 0 ? fullname : name,
	id: prefix + 'select_item_' + pid + '_' + vid
    });
    var icon = $('<i></i>', { class: 'fas fa-minus-circle ml-1' });
    selected_item.append(icon);

    $('#' + prefix + 'selected_list').append(selected_item);
}

// アプリケーションを選択する。
function select_item(pid, name, vid, fullname, prefix = '')  {
    if ($('#' + prefix + 'selected_list a').length >= 30) {
	alert('手動登録アプリケーションは既に30個まで選択されています。31個以上は登録できません。');
	return false;
    }
    var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    if (!m_selected[pid]) { m_selected[pid] = []; }
    for (var i = 0; i < m_selected[pid].length; i++) {
	if (m_selected[pid][i]['vid'] == vid) { return false; }
    }
    m_selected[pid].push({ pid: pid, name: name, vid: vid, fullname: fullname });
    $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    select_item_append(pid, name, vid, fullname, prefix);
    $('#' + prefix + 'searched_list > *').remove();
    $('#' + prefix + 'inc_search').val('');

    return false;
}

// アプリケーションを非選択にする。
function deselect_item(pid, vid, prefix = '') {
    $('#' + prefix + 'select_item_' + pid + '_' + vid).remove();
    var m_selected = JSON.parse($('#' + prefix + 'selected').val());
    if (!m_selected[pid]) { return false; }
    m_selected[pid] = m_selected[pid].filter(function(v, i) {
	return vid != v['vid'];
    });
    if (m_selected[pid].length == 0) { delete m_selected[pid]; }
    $('#' + prefix + 'selected').val(JSON.stringify(m_selected));
    return false;
}

// アプリケーション検索の処理
function inc_search_keyup(prefix = '') {
    return (function() {
	var f = $(this);
	var old_f = $('#' + prefix + 'inc_search_old');
	if (f.val() != old_f.val()) {
	    old_f.val(f.val());
	    var path = $('#sidfm_licenses_api_substr_search_path').val();
	    $.get(path, { 'params[keyword]': f.val() }, function(data) {
		var pids = Object.keys(data);
		$('#' + prefix + 'searched_list > *').remove();
		for (var i = 0; i < pids.length; i++) {
		    var product = data[pids[i]]['product'];
		    
		    var p_item = $('<span></span>', {
			class: 'dropdown'
		    });
		    p_item.append($('<button></button>', {
			class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
			type: 'button',
			id: prefix + 'searched_item_' + pids[i],
			'data-toggle': 'dropdown',
			'aria-haspopup': 'true',
			'aria-expanded': 'false',
			text: product['name']
		    }));
		    var p_menu = $('<div></div>', {
			class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
			'aria-labelledby': prefix + 'searched_item_' + pids[i]
		    });
		    var p_onclick =
			'select_item(' +
			pids[i] +
			',\'' +
			product['name'] +
			'\',0,\'\',\'' + prefix + '\')';
		    p_menu.append($('<a></a>', {
			class: 'dropdown-item',
			text: '全て',
		    href: '#',
			onclick: p_onclick
		    }));
		    
		    var versions = data[pids[i]]['versions'];
		    if (versions) {
			for (var j = 0; j < versions.length; j++) {
			    var version = versions[j];
			    p_onclick = 'select_item(' +
				pids[i] +
				',\'' +
				product['name'] + '\',' +
				version['vid'] + ',\'' +
				version['fullname'] +
				'\',\'' + prefix + '\')';
			    var p_ver = $('<a></a>', {
				class: 'dropdown-item',
				text: version['fullname'],
				href: '#',
				onclick: p_onclick
			    });
			    p_menu.append(p_ver);
			}
		    }
		    p_item.append(p_menu);
		    $('#' + prefix + 'searched_list').append(p_item);
		}
	    })
	    return true;
	}
    });
}

$(function() {

    init_sidfm();
    init_paginator();

    activate_sidebar_item('sidebar-item-hostadmin');

    // ホスト名検索
    $('.filter-keyword').on('click', function(e) {
	var keyword = $('#filters_search_keyword').val();
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String(keyword);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // ホスト名検索リセット
    $('.filter-keyword-reset').on('click', function(e) {
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String('');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // カテゴリ検索
    $('.category-change').on('click', function(e) {
	var button = $(this);
	var categoryid = button.data('categoryid');
	var filters = JSON.parse($('#pages_filters').val());
	filters['category_id'] = String(categoryid);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // 検索リセット
    $('.filter-reset').on('click', function(e) {
	var filters = JSON.parse($('#pages_filters').val());
	filters['hostname'] = String('');
	filters['category_id'] = String('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    // ホスト名変更ボタンを押下した際に実行される初期化処理
    $('#hostnameModal').on('show.bs.modal', function(e) {
	var button = $(e.relatedTarget);
	$('#hostnameModalOld').text(button.data('hostname'));
	$('#inputOldHostname').val(button.data('hostname'));
	$('#hostnameModalHostid').val(button.data('hostid'));
	return true;
    });

    $('#categories_new_select_category').on('click', function() {
	return move_selected_items_for_new_host('#categories_new_selected_category_ids',
				   '#categories_new_unselected_categories',
				   '#categories_new_selected_categories', false);
    });
    $('#categories_new_unselect_category').on('click', function() {
	return move_selected_items_for_new_host('#categories_new_selected_category_ids',
				   '#categories_new_selected_categories',
				   '#categories_new_unselected_categories', true);
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages').on('click', function(e) {
        var button = $(this);
        var target = $(button.data('target'));
        var dump = {
            'pages[offset]': $('#pages_offset').val(),
            'pages[per_page]': $('#pages_per_page').val(),
            'pages[order]' : $('#pages_order').val(),
            'pages[filters]': JSON.parse($('#pages_filters').val()),
            'pages[category_id]': $('#pages_category_id').val(),
            'pages[hostname]': $('#pages_hostname').val(),
            'pages[checked]': [],
            'pages[all_checked]': false
        };
        target.val(JSON.stringify(dump));
        //関連するルールのチェック
        if(button.attr('id') === 'host-category-change'){
            var hostid = $('#categories_sidfmdhostid').val();
            var form = $('#categories_form');
            var path = $('#sidfm_internal_api_check_related_rules_path').val();
            var category_ids = [];
            $('#categories_selected_categories option').each(function(){
                category_ids.push(parseInt($(this).val()));
            });
            $.ajax({
                url: path,
                type: 'POST',
                data: {
                    'page_name': 'hostadmin', 
                    'host_ids': JSON.stringify([hostid]),
                    'action_idx': 'category_change',
                    'category_ids': JSON.stringify(category_ids)
                },
                async: false
            }).done(function(data){
                var message = data['message'];
                if(message.length > 0){
                    var conf = confirm(message);
                    if(!conf){
                        return false;
                    }else{
                        delete data['message'];
                        form.append(
                            $('<input>').attr({'type': 'hidden', 'name': 'categories[rule_info]'}).val(JSON.stringify(data))
                        ).submit();
                    }
                }else{
                    form.submit();
                }
            });
        }else{
            return true;
        }
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages-confirm').on('confirm:complete', function(e, answer) {
	if (answer) {
	    var button = $(this);
	    var target = $(button.data('target'));
	    var dump = {
		'pages[offset]': $('#pages_offset').val(),
		'pages[per_page]': $('#pages_per_page').val(),
		'pages[order]' : $('#pages_order').val(),
		'pages[filters]': JSON.parse($('#pages_filters').val()),
		'pages[category_id]': $('#pages_category_id').val(),
		'pages[hostname]': $('#pages_hostname').val(),
		'pages[checked]': [],
		'pages[all_checked]': false
	    };
	    target.val(JSON.stringify(dump));
	}
	return true;
    });

    // メモ更新
    var memo_before_update = '';
    $('#memoModal').on('show.bs.modal', function(e) {
        $('#update-memo-label').hide();
        $('#execute-update-memo').prop('disabled', true);
	var button = $(e.relatedTarget);
        var host_memo = button.data('memo');
	$('#inputMemo_Hostname').val(button.data('hostname'));
	$('#inputMemo').val(host_memo);
  $('#tooltip_for_memo').attr('data-original-title', host_memo);
	$('#memoModalLabel').text(button.data('title'));
        memo_before_update = button.data('memo');
	return true;
    });

    // 基準日更新
    $('#refdateModal').on('show.bs.modal', function(e) {
	var button = $(e.relatedTarget);
	$('#inputRefdate_Hostname').val(button.data('hostname'));
	$('#inputRefdate').val(button.data('refdate'));
	$('#refdateModalLabel').text(button.data('title'));
	return true;
    });

    // カテゴリ編集
    $('#categoriesModal').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var sidfmdhostid = button.data('sidfmdhostid');
	var hostname = button.data('hostname');
	var title = button.data('title');
	var syscategory = button.data('syscategory');
	var categories = button.data('categories');

	if (typeof sidfmdhostid === 'undefined' || sidfmdhostid == '' || sidfmdhostid == 0) {
	    alert('不正な操作を確認したため、画面をリロードします。');
	    location.reload(true);
	    return false;
	}

	// hostid, hostnameの設定
	$('#categories_sidfmdhostid').val(sidfmdhostid);
	$('#categories_hostname').val(hostname);

	// タイトルの設定
	$(this).find('.modal-title').text(title);

	// システムカテゴリの設定
	$('#categories_system_categories > option').prop('selected', false);
	if (syscategory != null) {
	    $('#categories_system_categories > option[value="' + syscategory['id'] + '"]').prop('selected', true);
	}

	// その他カテゴリの設定
	var not_system_categories = JSON.parse($('#not_system_categories').val());
	var not_system_category_ids = not_system_categories.map(x => x['id']);
	var category_ids = categories.map(x => x ['id']);
	$('#categories_selected_categories > option').remove();
	$('#categories_unselected_categories > option').remove();
	for (var i = 0; i < not_system_categories.length; i++) {
	    var cat = not_system_categories[i];
	    var o = $($.inArray(cat['id'], category_ids) != -1 ? '#categories_selected_categories' : '#categories_unselected_categories').append($('<option></option>', { value: cat['id'], text: cat['name'], class: 'text-truncate g-max-width-21em' }));
	    o.attr('data-toggle', 'tooltip');
	    o.attr('title', cat['name']);
	}
	$('#categories_selected_category_ids').val(JSON.stringify(category_ids));

	return true;
    });

    // 選択されたカテゴリを選択済に移動
    $('#categories_select_category').on('click', function() {
	return move_selected_items('#categories_selected_category_ids',
				   '#categories_unselected_categories',
				   '#categories_selected_categories', false);
    });

    // 選択されたカテゴリを未選択に移動
    $('#categories_unselect_category').on('click', function() {
	return move_selected_items('#categories_selected_category_ids',
				   '#categories_selected_categories',
				   '#categories_unselected_categories', true);
    });

    // カテゴリ一括
    $('#categoriesBulkModal').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var checked = $('#pages_checked').val();
	var hostnames = JSON.parse(checked);
	if (hostnames.length > 0) {
	    $('#categories_bulk_hostnames').val(checked);
	    $('#categoriesBulkTargetList > *').remove();
	    for (var i = 0; i < hostnames.length; i++) {
		var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
		var c_td = $('<td></td>', { class: 'hostname' });
		c_td.text(hostnames[i]);
		c_tr.append(c_td);
		$('#categoriesBulkTargetList').append(c_tr);
	    }
	} else {
	    alert('対象ホストがチェックされておりません。');
	    location.reload(true);
	    return false;
	}
	return true;
    });
    $('#categories_bulk_select_category').on('click', function() {
	return move_selected_items('#categories_bulk_selected_category_ids',
				   '#categories_bulk_unselected_categories',
				   '#categories_bulk_selected_categories', false);
    });
    $('#categories_bulk_unselect_category').on('click', function() {
	return move_selected_items('#categories_bulk_selected_category_ids',
				   '#categories_bulk_selected_categories',
				   '#categories_bulk_unselected_categories', true);
    });

    //カテゴリ一括変更時に関連するルールをチェック
    $('#hosts-bulk-category-change').on('click', function(){
        var hostnames = JSON.parse($('#categories_bulk_hostnames').val());
        var form = $('#categories_bulk_form');
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        var category_ids = [];
        $('#categories_bulk_selected_categories option').each(function(){
            category_ids.push(parseInt($(this).val()));
        });
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'hostadmin',
                'hostnames': JSON.stringify(hostnames),
                'action_idx': 'bulk_category_change',
                'category_ids': JSON.stringify(category_ids)
            },
            async: false
        }).done(function(data){
            var message = data['message'];
            if(message.length > 0){
                var conf = confirm(message);
                if(!conf){
                    return false;
                }else{
                    delete data['message'];
                    form.append(
                        $('<input>').attr({'type': 'hidden', 'name': 'categories[rule_info]'}).val(JSON.stringify(data))
                    ).submit();
                }
            }else{
                form.submit();
            }
        });
    });

    // プロダクト一括
    $('#modalModifyAppBulk').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var checked = $('#pages_checked').val();
	var hostnames = JSON.parse(checked);
	if (hostnames.length > 0) {
	    $('#modifyappbulk_hostnames').val(checked);
	    $('#appBulkTargetList > *').remove();
	    for (var i = 0; i < hostnames.length; i++) {
		var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
		var c_td = $('<td></td>', { class: 'hostname' });
		c_td.text(hostnames[i]);
		c_tr.append(c_td);
		$('#appBulkTargetList').append(c_tr);
	    }
	} else {
	    alert('対象ホストがチェックされておりません。');
	    location.reload(true);
	    return false;
	}
	
	return true;
    });

    // 基準日一括
    $('#refdateBulkModal').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var checked = $('#pages_checked').val();
	var hostnames = JSON.parse(checked);
	if (hostnames.length > 0) {
	    $('#refdate_bulk_hostnames').val(checked);
	    $('#refdateBulkTargetList > *').remove();
	    for (var i = 0; i < hostnames.length; i++) {
		var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
		var c_td = $('<td></td>', { class: 'hostname' });
		c_td.text(hostnames[i]);
		c_tr.append(c_td);
		$('#refdateBulkTargetList').append(c_tr);
	    }
	} else {
	    alert('対象ホストがチェックされておりません。');
	    location.reload(true);
	    return false;
	}
	return true;
    });

    // メモ一括
    $('#memoBulkModal').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var checked = $('#pages_checked').val();
	var hostnames = JSON.parse(checked);
	if (hostnames.length > 0) {
	    $('#memo_bulk_hostnames').val(checked);
	    $('#memoBulkTargetList > *').remove();
	    for (var i = 0; i < hostnames.length; i++) {
		var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
		var c_td = $('<td></td>', { class: 'hostname' });
		c_td.text(hostnames[i]);
		c_tr.append(c_td);
		$('#memoBulkTargetList').append(c_tr);
	    }
	} else {
	    alert('対象ホストがチェックされておりません。');
	    location.reload(true);
	    return false;
	}
	return true;
    });

    $('#offlineModal').on('show.bs.modal', function(event) {
	$('#offlineInput').fileinput({uploadExtraData: {
	    'system_category_id':'1',
	    'custom_category_id':$($('#offlineCustomCategory > option')[0]).val()
	} });
	$('#offlineInput').on('fileloaded', function(event, file, previewId, index, reader) {
	    var captions = $('#offlineModal tbody.file-preview-thumbnails > tr.file-preview-frame > td.file-details-cell > div.explorer-caption');
	    var previewIds = previewId.split('-');
	    var previewIdNum = parseInt(previewIds[2]);
	    var caption = $(captions[previewIdNum]);
	    var is_valid = false;
	    var hostname = '';
	    try {
		var data = JSON.parse(reader['result']);
		hostname = data['hostname'];
		if (hostname) { is_valid = true; }
	    } catch (e) {
		console.log(e);
	    }
	    caption.find('span').remove();
	    if (is_valid) {
		// JSON正常、hostname正常
		var path = $('#sidfm_internal_api_check_hostname_path').val();
		$.get(path, { 'params[hostname]':hostname }, function(data) {
		    caption.find('span').remove();
		    if (!data['exist'] && data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: '新ホストとして登録されます',
			    class: 'bg-warning text-black g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    } else if (data['exist'] && !data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: 'アクセス不可',
			    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    } else if (!data['accessable']) {
			var msg_invalid = $('<span></span>', {
			    text: 'アクセス不可',
			    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
			});
			caption.append(msg_invalid);
		    }
		    return true;
		});
	    } else {
		// JSON不正もしくはhostname不正
		var msg_invalid = $('<span></span>', {
		    text: 'データが不正ですので確認してください',
		    class: 'bg-danger text-white g-font-size-0_80x d-inline-block b_radius px-1 ml-1'
		});
		caption.append(msg_invalid);
	    }
	    return true;
	});
	return true;
    });
    $('#offlineModal').on('hidden.bs.modal', function(event) {
	$('#offlineInput').fileinput('clear');
	return true;
    });
    $('#offlineSystemCategory').on('change', function() {
	($('#offlineInput').data('fileinput').uploadExtraData)['system_category_id'] = '' + $('#offlineSystemCategory').val();
    });
    $('#offlineCustomCategory').on('change', function() {
	($('#offlineInput').data('fileinput').uploadExtraData)['custom_category_id'] = '' + $('#offlineCustomCategory').val();
    });

    // ホスト毎のcheckboxを変更した際の処理
    $('.hostSelect').on('change', function() {
	var checkbox = $(this);
	var hostname = checkbox.val();
	var checked = JSON.parse($('#pages_checked').val());
	var all_hostnames = JSON.parse($('#all_hostnames').val());
	var all_host_size = all_hostnames.length;
	if (checkbox.prop('checked')) {
	    if (!checked.includes(hostname)) {
		checked.push(hostname);
		if (checked.length == all_host_size) {
		    $('.allHostSelect').prop('checked', true);
		    $('#pages_all_checked').val('true');
		} else {
		    $('.allHostSelect').prop('checked', false);
		    $('#pages_all_checked').val('false');
		}
		$('#pages_checked').val(JSON.stringify(checked));
	    }
	} else {
	    var idx = checked.indexOf(hostname);
	    if (idx == 0) {
		checked = checked.slice(1, all_host_size);
	    } else if (idx == all_host_size - 1) {
		checked = checked.slice(0, all_host_size - 1);
	    } else if (idx > 0) {
		var c_left = checked.slice(0, idx);
		var c_right = checked.slice(idx + 1, all_host_size);
		checked = c_left.concat(c_right);
	    }
	    $('#pages_checked').val(JSON.stringify(checked));
	    if (checked.length == all_host_size) {
		$('.allHostSelect').prop('checked', true);
		$('#pages_all_checked').val('true');
	    } else {
		$('.allHostSelect').prop('checked', false);
		$('#pages_all_checked').val('false');
	    }
	}
	return true;
    });

    // 全ホストチェックのcheckboxを変更した際の処理
    $('.allHostSelect').on('change', function() {
	var checkbox = $(this);
	if (checkbox.prop('checked')) {
	    $('#pages_checked').val($('#all_hostnames').val());
	    $('#pages_all_checked').val('true');
	    $('.hostSelect').prop('checked', true);
	} else {
	    $('#pages_checked').val(JSON.stringify([]));
	    $('#pages_all_checked').val('false');
	    $('.hostSelect').prop('checked', false);
	}
	return true;
    });
  
  //全ホストチェックのcheckboxを押下後にリセットボタンを押した時の処理
  if(JSON.parse($('#pages_checked').val()).length === JSON.parse($('#all_hostnames').val()).length){
      $('.allHostSelect').prop('checked', true);
  }else{
      $('.allHostSelect').prop('checked', false);
  }

    // ホスト登録ボタンを押下した際に実行される初期化処理
    $('.btn-registhost').on('click', function() {
	$('#form_hostname').val('');
	$('#form_categories > option').prop('selected', false);
	$('#inc_search').val('');
	$('#selected').val('{}');
	$('#searched_list > *').remove();
	$('#selected_list > *').remove();
  $('#new_host_regist_btn').prop('disabled', true);
  $('#warning-hostname').hide();
  $('#warning-no-category').hide();
  $('#warning-memo').hide();
  $('#form_memo').val('');
    });

    // アプリケーション変更ボタンを押下した際に実行される初期化処理
    $('.btn-modifyapp').on('click', function() {
	var hostname = $(this).data('hostname');
	$('.modifyapp_hostname').text(hostname);
	$('#modifyapp_hostname').val(hostname);
	$('#m_inc_search').val('');
	$('#m_searched_list > *').remove();
	$('#m_selected_list > *').remove();
	
	var path = $('#sidfm_licenses_api_get_apps_by_hostname_path').val();
	$.get(path, { 'params[hostname]': hostname }, function(data) {
	    var m_selected = data;
	    $('#m_selected').val(JSON.stringify(data));
	    var keys = Object.keys(data);
	    for (var i = 0; i < keys.length; i++) {
		var items = data[keys[i]];
		for (var j = 0; j < items.length; j++) {
		    var item = items[j];
		    select_item_append(item['pid'], item['name'],
				       item['vid'], item['fullname'], 'm_')
		}
	    };
	    return true;
	});
    });

    // アプリ変更時のアプリケーション検索
    (function() {

	$('#m_inc_search').on('keyup', function() {
	    var f = $(this);
	    var old_f = $('#m_inc_search_old');
	    if (f.val() != old_f.val()) {
		old_f.val(f.val());
		var path = $('#sidfm_licenses_api_substr_search_path').val();
		$.get(path, { 'params[keyword]': f.val() }, function(data) {
		    var pids = Object.keys(data);
		    $('#m_searched_list > *').remove();
		    for (var i = 0; i < pids.length; i++) {
			var product = data[pids[i]]['product'];

			var p_item = $('<span></span>', {
			    class: 'dropdown'
			});
			p_item.append($('<button></button>', {
			    class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
			    type: 'button',
			    id: 'm_searched_item_' + pids[i],
			    'data-toggle': 'dropdown',
			    'aria-haspopup': 'true',
			    'aria-expanded': 'false',
			    text: product['name']
			}));
			var p_menu = $('<div></div>', {
			    class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
			    'aria-labelledby': 'm_searched_item_' + pids[i]
			});
			var p_onclick =
			    'select_item(' +
			    pids[i] +
			    ',\'' +
			    product['name'] +
			    '\',0,\'\',\'m_\')';
			p_menu.append($('<a></a>', {
			    class: 'dropdown-item',
			    text: '全て',
			    href: '#',
			    onclick: p_onclick
			}));

			var versions = data[pids[i]]['versions'];
			if (versions) {
			    for (var j = 0; j < versions.length; j++) {
				var version = versions[j];
				p_onclick = 'select_item(' +
				    pids[i] +
				    ',\'' +
				    product['name'] + '\',' +
				    version['vid'] + ',\'' +
				    version['fullname'] +
				    '\',\'m_\')';
				var p_ver = $('<a></a>', {
				    class: 'dropdown-item',
				    text: version['fullname'],
				    href: '#',
				    onclick: p_onclick
				});
				p_menu.append(p_ver);
			    }
			}
			p_item.append(p_menu);
			$('#m_searched_list').append(p_item);
		    }
		})
		return true;
	    }
	});

    })();


    // ホスト登録時のアプリケーション検索
    (function() {

	$('#inc_search').on('keyup', function() {
	    var f = $(this);
	    var old_f = $('#inc_search_old');
	    if (f.val() != old_f.val()) {
		old_f.val(f.val());
		var path = $('#sidfm_licenses_api_substr_search_path').val();
		$.get(path, { 'params[keyword]': f.val() }, function(data) {
		    var pids = Object.keys(data);
		    $('#searched_list > *').remove();
		    for (var i = 0; i < pids.length; i++) {
			var product = data[pids[i]]['product'];

			var p_item = $('<span></span>', {
			    class: 'dropdown'
			});
			p_item.append($('<button></button>', {
			    class: 'btn btn-outline-dark mb-1 mr-1 dropdown-toggle',
			    type: 'button',
			    id: 'searched_item_' + pids[i],
			    'data-toggle': 'dropdown',
			    'aria-haspopup': 'true',
			    'aria-expanded': 'false',
			    text: product['name']
			}));
			var p_menu = $('<div></div>', {
			    class: 'dropdown-menu scrollable-menu-30vh s-shadow-v1',
			    'aria-labelledby': 'searched_item_' + pids[i]
			});
			var p_onclick =
			    'select_item(' +
			    pids[i] +
			    ',\'' +
			    product['name'] +
			    '\',0,\'\')';
			p_menu.append($('<a></a>', {
			    class: 'dropdown-item',
			    text: '全て',
			    href: '#',
			    onclick: p_onclick
			}));

			var versions = data[pids[i]]['versions'];
			if (versions) {
			    for (var j = 0; j < versions.length; j++) {
				var version = versions[j];
				p_onclick = 'select_item(' +
				    pids[i] +
				    ',\'' +
				    product['name'] + '\',' +
				    version['vid'] + ',\'' +
				    version['fullname'] +
				    '\')';
				var p_ver = $('<a></a>', {
				    class: 'dropdown-item',
				    text: version['fullname'],
				    href: '#',
				    onclick: p_onclick
				});
				p_menu.append(p_ver);
			    }
			}
			p_item.append(p_menu);
			$('#searched_list').append(p_item);
		    }
		})
		return true;
	    }
	});
	return true;
    });

    // ソート
    $('.sort-hostname').on('click', sort_toggle('hostname'));
    $('.sort-category').on('click', sort_toggle('category'));
    $('.sort-os').on('click', sort_toggle('os'));
    $('.sort-agentprds').on('click', sort_toggle('agentprds'));
    $('.sort-prds').on('click', sort_toggle('prds'));
    $('.sort-refdate').on('click', sort_toggle('refdate'));
    $('.sort-memo').on('click', sort_toggle('memo'));
    $('.sort-manual').on('click', sort_toggle('manual'));
    $('.sort-agent').on('click', sort_toggle('agent'));

    // アプリケーション検索処理
    $('#inc_search').on('keyup', inc_search_keyup(''));
    $('#m_inc_search').on('keyup', inc_search_keyup('m_'));
    $('#bulk_inc_search').on('keyup', inc_search_keyup('bulk_'));
   
    //メモ更新時の文字チェック
    $('#inputMemo').on('input', function(){
        var memo = $(this).val();
        if(memo.length > 100){
            $('#update-memo-label').text('100文字以内で入力して下さい').css('color', 'red').show();
            $('#execute-update-memo').prop('disabled', true);
        }else{
           $('#update-memo-label').hide();
           $('#execute-update-memo').prop('disabled', false);
        }
        if(memo_before_update === memo){
           $('#execute-update-memo').prop('disabled', true);
        } 
    });
    $('#form_update_memo').on('submit', function(){
        if($('#execute-update-memo').attr('disabled')){
            return false;
        }
    });
    $('#form_regist_host').on('submit', function(){
        if($('#new_host_regist_btn').attr('disabled')){
            return false;
        }
    });
    $('#execute-update-memo').on('click', function(){
         $('#form_update_memo').submit();
    });
    $('#new_host_regist_btn').on('click', function(){
        $('#form_regist_host').submit();
    });
    
    //ホスト新規登録時に登録可能かチェック
    $('#categories_new_unselect_category, #categories_new_select_category').on('click',check_register_validity);        
    $('#form_hostname, #form_memo').on('input',check_register_validity);
    $('#inputRefdateNew').on('change',check_register_validity);
    function check_register_validity(){
            var path = $('#sidfm_licenses_api_validate_new_host_path').val();
             $.get(path)
            .done(function(data) {
            var existing_hostnames = data;
            var err_flag = 0;
            var same_hostname_flag = 0;
            var is_admin = JSON.parse($('#self_user_role').val()).includes('admin');
            var hostname = $('#form_hostname').val();
            var memo = $('#form_memo').val();
            var date = $('#inputRefdateNew').val().replace(/\//g, ',');
            var date_for_validation = new Date(date);
            var month = date.split(',')[1] - 1;
            if(date_for_validation.getMonth() != month){
                err_flag = 1;
                $('#warning-date').show();
            }else{
                $('#warning-date').hide();
            }
            existing_hostnames.forEach(function(e_hostname){
                if(e_hostname === hostname){
                    $('#warning-hostname').text('同名のホストが登録されています').show();
                    same_hostname_flag = 1;
                    err_flag = 1;
                }
            });
            if(hostname === ''){
                err_flag = 1;
                $('#warning-hostname').hide();
            }else if(!hostname.match(/^[\x20-\x7e]*$/)){
                $('#warning-hostname').text('半角英数字で入力して下さい').show();
                err_flag = 1;
            //}else if(hostname.match(/[@\\^*+={}~()'$#"\!%&\?/<>,;:\[\]\|`]/)){
            }else if(hostname.match(/\s/)){
                $('#warning-hostname').text('空白文字は使用できません').show();
                err_flag = 1;
            }else if(!hostname.match(/[0-9a-zA-Z._-]+/)){
                $('#warning-hostname').text('使用できない文字が含まれています').show();
                err_flag = 1;
            }else{
                if(same_hostname_flag === 0){
                    $('#warning-hostname').hide();
                }
            }
            if(memo.length > 100){
                err_flag = 1;
                $('#warning-memo').text('100文字以内で入力して下さい').show();
            }else{
                $('#warning-memo').hide();
            }
            if(!is_admin){
                if($('#categories_new_selected_categories option').length === 0){
                    err_flag = 1;
                    $('#warning-no-category').show();
                }else{
                    $('#warning-no-category').hide();
                 
                }
            } 
            if(err_flag === 1){
                $('#new_host_regist_btn').prop('disabled', true);
            }else{
                 $('#new_host_regist_btn').prop('disabled', false);
            }
       });
    }
    function move_selected_items_for_new_host(p_selected_ids, p_current_selected, p_opposite_selected, flg_reverse) {
        var selected_ids = JSON.parse($(p_selected_ids).val());
        var options = $(p_current_selected + ' > option:selected');
        for (var i = 0; i < options.length; i++) {
            var option = $(options[i]);
            var s_id = parseInt(option.val());
            var s_text = option.text();
            if (flg_reverse) {
                selected_ids = selected_ids.filter(function(x, i, self) {
                    return x != s_id;
                });
                selected_ids = selected_ids.filter(function(x, i, self) {
                    return self.indexOf(x) == i;
                });
            } else {
               selected_ids.push(s_id);
               selected_ids = selected_ids.filter(function(x, i, self) {
                   return self.indexOf(x) == i;
               });
            }
            $(p_selected_ids).val(JSON.stringify(selected_ids));
            $(p_opposite_selected).append($('<option></option>', { value: s_id, text: s_text, class: 'text-truncate g-max-width-21em' }));
       }
           $(p_current_selected + ' > option:selected').remove();
       return false;
    }
    //クリップボードのコピー
    const clipboard = new ClipboardJS('.copybtn');
    const clipboard_supported = ClipboardJS.isSupported();
    //クリップボードがサポートされていなければアラートを表示
    $(document).on('mousedown', '.copybtn', function(e) {
        if(clipboard_supported === false) {
            alert('このブラウザではコピー機能はサポートされておりません');
            return false;
        }
    });
        
    var isSuccess = false;   
    $('.action-open-list').on('shown.bs.popover', function(e){
        $(this).on('hide.bs.popover', function(){
            if(isSuccess === true){
                var btn = $(this).find('.product-btn').tooltip('show');
                isSuccess = false;
                setTimeout(function (){
                    btn.tooltip('hide');
                },1000);
            }
        });
    });
   
    $(document).on('click', '.close-list', function(e){
        isSuccess = false;
        $(e.target).closest('.popover').popover('hide');
    });
 
    clipboard.on('success', function(e) {
        isSuccess = true;
        $(e.trigger).closest('.popover').popover('hide'); 
        e.clearSelection();
    });

    clipboard.on('error', function(e) {
        alert('コピーに失敗しました');
        e.clearSelection();
    });
    
    sticky_control('HostTable', 'licence');
  $('.synchronize-status-btn').on('show.bs.dropdown',function(){
      $(this).tooltip('hide');
      $(this).tooltip('disable');
      $(this).find('.select-synchro-time').addClass('synchro-time-show');
  });
  $('.synchronize-status-btn').on('hidden.bs.dropdown',function(){
      $(this).tooltip('enable');
      $(this).find('.select-synchro-time').removeClass('synchro-time-show');
  });
  $('.synchronize-status-btn option').on('click', function(e){
      e.stopPropagation();
  });
  
  $('.select-synchro-time').on('change',function(){
      if($(this).find('option:selected').length > 0){
          $(this).closest('.synchronize-status-btn')
                 .find('.execute-set-last-checked-at')
                 .prop('disabled', false);
      }else{
          $(this).closest('.synchronize-status-btn')
                 .find('.execute-set-last-checked-at')
                 .prop('disabled', true);
      }
  });

  $('.execute-set-last-checked-at').on('click', function(e){
      $('.popover').css('z-index', '500');
      var synchro_status_btn = $(this).closest('.synchronize-status-btn');
      var hostid = $(this).val();
      var time = synchro_status_btn.find('.select-synchro-time option:selected').val();
      var value = {'hostid':hostid, 'time':time}
      $('#param_set_last_checked_at').val(JSON.stringify(value));
      var path = $('#sidfm_licenses_api_get_new_last_checked_at_path').val();
      $.post(path, {'time_with_hostid': JSON.stringify(value)})
      .done(function(data){
          var set_time = data[0];
          var synchro_time = data[1];
          var backdrop = $('<div>').attr('class', 'backdrop');
          $('body').append(backdrop);
          var alert_window = $('<div>').attr('class', 'synchro-alert');
          var message = $('<div>').attr('class', 'd-flex');
          var wrap_ex_mark = $('<div>').attr('class', 'mr-3 ml-2');
          var ex_mark = $('<i>').attr('class', 'fas fa-exclamation-circle fa-3x ex-mark');
          wrap_ex_mark.append(ex_mark);
          message.append(wrap_ex_mark);
          if(set_time == 'now'){
              var message_text = $('<div>').attr('class', 'mr-1')
                                           .html('<div class="mb-2">次の同期を <span class="font-weight-bold">0～10分後</span>に実行します。<br>よろしいですか？</div><div class="g-font-size-13 g-line-height-1_4 mb-3">※複数のホストでの同期処理による不具合を避ける処理を行っているため、複数のホストの同期時刻を同じに設定すると実際の同期時刻が遅れる場合があります。</div>'); 
             alert_window.addClass('');
          }else{
              var message_text = $('<div>').attr('class', 'mr-1')
                                           .html('<div class="mb-2">次の同期を <span class="font-weight-bold">' + synchro_time + ' </span>に実行します。<br>よろしいですか？</div><div class="g-font-size-13 g-line-height-1_4 mb-1">※現在、設定されている脆弱性更新日時から 24時間経過した後のタイミングで日時が設定されます。</div><div class="g-font-size-13 g-line-height-1_4 mb-3">※複数のホストでの同期処理による不具合を避ける処理を行っているため、複数のホストの同期時刻を同じに設定すると実際の同期時刻が遅れる場合があります。</div>' );
            alert_window.addClass('');
          }
          message.append(message_text);
          alert_window.append(message);
          var div = $('<div>').attr('class', 'd-flex justify-content-end');
          var ok_btn = $('<button>').attr({
                                     'class': 'g-font-size-13 alert-ok-btn btn btn-xs btn-primary text-nowrap',
                                     'type': 'button'
                                    })
                                    .text('実行');
          var cancel_btn = $('<button>').attr({
                                         'class': 'g-font-size-13 ml-1 alert-cancel-btn btn btn-xs btn-secondary text-nowrap',
                                         'type':'button'
                                        })
                                        .text('キャンセル');
          div.append(ok_btn);
          div.append(cancel_btn);
          alert_window.append(div);
          $('body').append(alert_window);
          var offset = $('.synchro-time-show').offset();
          alert_window.offset({'top':offset.top - alert_window.height() - 3, 'left':offset.left - 10});
          $('#wrap-ActionArea').css('z-index', '500'); 
          $('#floating-scroll').css('z-index', '500');
       });
      e.stopPropagation();
  });

  $(window).on('resize', function(){
      if($('.synchro-alert').length === 1){
          var target = $('.synchro-time-show');
          var offset = target.offset();
          var alert_window = $('.synchro-alert');
          alert_window.offset({'top':offset.top - alert_window.height() - 3, 'left':offset.left - 10});
      }
  });

  $(document).on('click', '.backdrop', function(e){
      e.stopPropagation();
  });

  $(document).on('click', '.synchro-alert', function(e){
      e.stopPropagation();
  });
  
  $(document).on('click', '.alert-ok-btn', function(){
      $('#form_set_last_checked_at').submit();
  });

  $(document).on('click', '.alert-cancel-btn', function(e){
      $('.synchro-alert').remove();
      $('.backdrop').remove();
      $('#wrap-AcrionArea').css('z-index', '1045');
      $('#floating-scroll').css('z-index', '1060');
      $('.popover').css('z-index', '1060');
      e.stopPropagation();
  });


  $(window).on('load', function() {
      setTimeout(function(){
          set_scroll();
          $(window).on('resize scroll', set_scroll);
      },200);
      $('.modal').on('show.bs.modal', function(){
          $('#floating-scroll').css('z-index', '10');
      });
      $('.modal').on('hidden.bs.modal', function(){
          $('#floating-scroll').css('z-index', '1060');
      });
  });

  $('.modal').on('show.bs.modal', function(){
      $('.popover').css('z-index', '100');
  });
  $('.modal').on('hidden.bs.modal',function(){
      $('.popover').css('z-index', '1060');
  });

  //popoverのバルーンが、サマリー表の一番上もしくは一番下に到達したらバルーンを非表示にする
  $(window).on('scroll', function(){
      var bottom_of_header = $('#HEADnavi').outerHeight(true);
      var bottom_of_summary_table = $('#wrap-ActionArea').offset().top - 10;
      $('.popover[class*="show"]').each(function(){
          var balloon_offset_top = $(this).offset().top;
          if(balloon_offset_top - $(window).scrollTop() <= bottom_of_header || balloon_offset_top + $(this).outerHeight(true) >= bottom_of_summary_table){
              $('[data-toggle="popover"]').popover('hide');
              return false;
          }
      });
  });
  
  //ホスト削除時にルールをチェック
  $('[data-delhost]').on('click', function(){
      var button = $(this);
      var del_hostid = button.attr('data-delhost');
      var form = $('[data-formdel="host_' + del_hostid + '"]');
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      $.ajax({ 
        url: path,
        type: 'POST',
        data: {'page_name': 'hostadmin', 'delete_id': del_hostid},
        async: false
      }).done(function(data){
          var message = data['message'];
          if(message.length > 0){
              var conf = confirm(message);
              if(!conf){
                  return false;
              }else{
                  delete data['message'];
                  form.append(
                      $('<input>').attr({'type': 'hidden', 'name': 'params[rule_info]'}).val(JSON.stringify(data))
                  ).submit();
             }
          }else{
              var conf = confirm('削除してもよろしいですか?');
              if(!conf){
                  return false;
              }else{
                  form.submit();
              }
          }
      });
  });
    
});
