/* Copyright (C) 2018 SofTek Systems, Inc. */

// サイドメニュー用
// 全画面に影響する初期化もこちらで設定。

function applyDropdownToggle() {
    $('.dropdown-menu a.dropdown-toggle').on('click', function(ev) {
	if (!$(this).next().hasClass('show')) {
	    $(this).parents('.dropdown-menu').first().find('.show').removeClass("show");
	}
	var $subMenu = $(this).next(".dropdown-menu");
	$subMenu.toggleClass('show');
	$(this).parents('.dropdown.show').on('hidden.bs.dropdown', function() {
	    $('.dropdown-submenu .show').removeClass("show");
	});
	$(this).parents('.dropright.show').on('hidden.bs.dropdown', function() {
	    $('.dropdown-submenu .show').removeClass("show");
	});
	return false;
    });
}

$(function () {

    init_sidfm();

    // mCustomScrollbar の初期化、テーマ選択
    $("#sidebar").mCustomScrollbar({
	theme: "minimal",
	scrollInertia: 100
    });

    // sidebar dropdown 制御(JQUERY)
    (function() {
	// 開閉状態の保持 (sesson only)
	var c = $.cookie('sidebar_opened');
	if (c) {
	    c = ("true" === c);
	    if (!c) {
		$('#sidebar, #content-block').addClass('active');
	    }
	} else {
	    // 開いた状態をデフォルトとする
	    $.cookie('sidebar_opened', 'true');
	}
    })();
    // 画面表示、リサイズの際に、ウインドウサイズに応じて開閉する
    (function() {
	var t = $('#sidebar, #content-block');
	var sW = window.innerWidth;
	if (sW < 1200) {
	    t.addClass('auto-active');
	}
	$(window).on('load resize', function() {
	    var windowWidth = window.innerWidth;
	    if (windowWidth < 1200) {
		t.addClass('auto-active');
	    } else {
		t.removeClass('auto-active');
	    }
	});
    })();
    // 開閉ボタンを押下した際に開閉する
    $('#SidebarCollapse').on('click', function () {
  	var t = $('#sidebar, #content-block');
  	if (t.hasClass('auto-active')) {
  	    t.removeClass('auto-active');
  	    t.addClass('active');
	    $.cookie('sidebar_opened', 'true');
  	}
	if (t.hasClass('active')) {
	    $.cookie('sidebar_opened', 'true');
	} else {
	    $.cookie('sidebar_opened', 'false');
	}
	t.toggleClass('active');
	$('.collapse.in').toggleClass('in');
	$('a[aria-expanded=true]').attr('aria-expanded', 'false');
    if($('#floating-scroll').length != 0){
        setTimeout(set_scroll, 200);
    }   
    });

    applyDropdownToggle();

    // ホスト名検索
    $('#sidemenu_hostsearch').on('keyup', function(ev) {
	var f = $(this);
	var old_f = $('#sidemenu_hostsearch_old');
	if (f.val() != old_f.val()) {
	    old_f.val(f.val());
	    var path = $('#sidfm_internal_api_hosts_path').val();
	    $.get(path, { 'params[keyword]': f.val() }, function(data) {
          if(data != null){
		          var options = $.map(data, function(n, i) {
		          var option = $('<option></option>', {
                  value: n.id,
		              text: n.hostname,
		              'class': 'sidebar-select-hostlist-link',
		              'data-hostid': n.id
		              });
		           return option;
               });
 	             $('#sidebar-select-hostlist > option').remove();
               $('#sidebar-select-hostlist').append(options);
           }else{
               $('#sidebar-select-hostlist > option').remove();
           }
           $('.sidebar-select-hostlist-link').on('click', function() {
		           var e = $(this);
		           var hostid = e.data('hostid');
		           location.href = url_host_detail(hostid);
		           return false;
           });
      });
      ev.preventDefault();
	}
	return true;
    });

    // 脆弱性検索 : 危険度指標
    $('.sidemenu-vulssearch-riskmenu').on('click', function(ev) {
	var link = $(this);
	var rtype = link.data('riskmenu-type');
	var level = link.data('riskmenu-level');
	var unit = link.data('riskmenu-unit');
	var num = link.data('riskmenu-num');
	var ul = link.next('ul');
	ul.children('li').remove();
	var path = $('#sidfm_internal_api_vulnerabilities_risk_period_path').val();
	$.get(path, {
	    'params[risk_type]': rtype,
	    'params[risk_level]': level,
	    'params[unit]': unit,
	    'params[num]': num
	}, function(data) {
	    if (data.length > 0) {
		var items = $.map(data, function(n, i) {
		    var li = $('<li></li>');
		    var a = $('<a></a>', {
			class: 'dropdown-item',
			href: url_vulnerabilities_detail(n.html_id)
		    });
		    a.text(n.created_on + ' ' + n.title);
		    li.append(a);
		    return li;
		});
		ul.append(items);
	    } else {
		var item = $('<li></li>');
		var a = $('<a></a>', {
		    class: 'dropdown-item',
		    href: '#'
		});
		a.text('指定の期間には脆弱性は登録されておりません。');
		item.append(a);
		ul.append(item);
	    }
	    applyDropdownToggle();
	});
	return true;
    });

    // 脆弱性検索 : 検出時期
    $('.sidemenu-vulssearch-timemenu').on('click', function(ev) {
	var link = $(this);
	var unit = link.data('timemenu-unit');
	var num = link.data('timemenu-num');
	var ul = link.next('ul');
	ul.children('li').remove();
	var path = $('#sidfm_internal_api_vulnerabilities_period_path').val();
	$.get(path, {
	    'params[unit]': unit, 'params[num]': num
	}, function(data) {
	    if (data.length > 0) {
		var items = $.map(data, function(n, i) {
		    var li = $('<li></li>');
		    var a = $('<a></a>', {
			class: 'dropdown-item',
			href: url_vulnerabilities_detail(n.html_id)
		    });
		    a.text(n.created_on + ' ' + n.title);
		    li.append(a);
		    return li;
		});
		ul.append(items);
	    } else {
		var item = $('<li></li>');
		var a = $('<a></a>', {
		    class: 'dropdown-item disabled',
		    href: '#'
		});
		a.text('指定の期間には脆弱性は登録されておりません。');
		item.append(a);
		ul.append(item);
	    }
	    applyDropdownToggle();
	});
	return true;
    });

    // 脆弱性検索
    $('#sidemenu_vulsearch').on('keyup', function(ev) {
	var f = $(this);
	var old_f = $('#sidemenu_vulsearch_old');
	if (f.val() != old_f.val()) {
	    old_f.val(f.val());
	    if (f.val().length == 0) {
 		$('#sidebar-select-vullist > option').remove();
		return true;
	    }
	    var path = $('#sidfm_internal_api_vulnerabilities_path').val();
	    $.get(path, { 'params[keyword]': f.val() }, function(data) {
                if(data != null){
		    var options = $.map(data, function(n, i) {
		        var option = $('<option></option>', {
			    value: n['html_id'],
			    text: n['title'],
			    'class': 'sidebar-select-vullist-link',
			    'data-htmlid': n['html_id']
		        });
		        return option;
		    });
 		    $('#sidebar-select-vullist > option').remove();
		    $('#sidebar-select-vullist').append(options);
		    $('.sidebar-select-vullist-link').on('click', function(evt) {
		        evt.preventDefault();
		        var e = $(this);
		        var htmlid = e.data('htmlid');
		        location.href = url_vulnerabilities_detail(htmlid);
		        return true;
		    });
                }
            });
	    ev.preventDefault();
	    return true;
	}
	return true;
    });


});

// bootstrapとjquery-uiの競合対策
$.widget.bridge('uibutton', $.ui.button);
$.widget.bridge('uitooltip', $.ui.tooltip);
