/* coding: utf-8 */
/* Copyright (C) 2019 SofTek Systems, Inc. */


$(function() {
    
    init_paginator();
    
    //ソート処理
    $('.sort-loginname').on('click', sort_toggle('loginname'));
    $('.sort-lastname').on('click', sort_toggle('lastname'));
    $('.sort-authway').on('click', sort_toggle('authway'));
    $('.sort-mail-notification').on('click', sort_toggle('mail-notification'));

    //検索処理
    
    function search_users(selector, search_item) {
        return (function () {
            var filters = JSON.parse($('#pages_filters').val());
            if (selector != '#search-self-user' && search_item === 'search_login' || search_item === 'search_name'){
                var kwd = $(selector).val();
            } else {
                var kwd = $(this).data('value');
            }
            filters[search_item] = String(kwd);
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
            return false;
        });
    }
    if ($('#pages_all_checked').val() === 'false'){ $('#allSelect').prop('checked', false);} 
 
    $('#filter_login').on('click', search_users('#filters_search_login', 'search_login'));
    $('#filter_name').on('click', search_users('#filters_search_name', 'search_name'));
    $('.filter_auth').on('click', search_users('#filters_search_auth', 'search_auth'));
    $('.filter_users_auth').on('click', search_users('.filter_users_auth', 'search_users_auth'));
    $('.filter_category').on('click', search_users('.filter_category', 'search_category'));
    $('#search-self-user').on('click', search_users('#search-self-user', 'search_login'));
    $('.filter_mail_notification').on('click', search_users('.filter_mail_notification', 'search_mail_notification'));
    $(document).on('click', '[data-search="category"]', function(event){
        event.preventDefault();
        var category_id = $(this).attr('data-value');
        var filters = JSON.parse($('#pages_filters').val());
        filters['search_category'] = String(category_id);
        $('#pages_filters').val(JSON.stringify(filters));
        $('#pages_offset').val('0');
        $('#pages_form').submit();
    });
    //検索リセット処理
    
    function reset_search_item(reset_item){
        return (function(){
            var filters = JSON.parse($('#pages_filters').val());
            filters[reset_item] = String('');
            $('#pages_filters').val(JSON.stringify(filters));
            $('#pages_offset').val('0');
            $('#pages_form').submit();
            return false;
         });
    }
    $('#filter_login_reset').on('click', reset_search_item('search_login'));
    $('#filter_name_reset').on('click', reset_search_item('search_name'));
    
        
    $('#filter-clear').on('click', function() {
        $('#pages_filters').val('{}') 
        $('#pages_offset').val('0');
        $('#pages_form').submit();
        return false;
    });
    
    //全ユーザチェックのcheckboxのリセット処理
    if($('#all_userids_names').length){ 
        var all_users_param = JSON.parse($('#all_userids_names').val());
        var count_userids = 0;
        for (id in all_users_param){
            count_userids += 1;
        } 
        if (JSON.parse($('#pages_checked').val()).length === count_userids){
            $('.allUserSelect').prop('checked', true);
        }else{
            $('.allUserSelect').prop('checked', false);
        }
    } 
    
    //モーダルでのカテゴリ編集処理
    $('#categoriesModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var title = button.data('title');
        var userid = parseInt(button.data('userid'));
        $(this).find('.modal-title').text(title);
        $('#categories_userid').val(userid);
        var cats = button.data('categories');
        var user_cats = button.data('user_category_ids');
        set_paginator_parameter("#cat_per_page", "#cat_filters", "#cat_offset", "#cat_order");
        $('#selected_categories > option').remove();
        $('#unselected_categories > option').remove();
        for (var key in cats) {
            $($.inArray(key - 0, user_cats) != -1 ? '#selected_categories' : '#unselected_categories').append($('<option></option>', { value: key, text: cats[key], class: 'text-truncate g-max-width-21em', 'data-toggle': 'tooltip', title: cats[key]  }));
        }
        $('#selected_category_ids').val(JSON.stringify(user_cats));
   
        return true;
    });
      
    $('#select_category').on('click', function() {
        return move_selected_items('#selected_category_ids',
                                   '#unselected_categories',
                                   '#selected_categories', false);
    });
    
    $('#unselect_category').on('click', function() {
        return move_selected_items('#selected_category_ids',
                                   '#selected_categories',
                                   '#unselected_categories', true);
    });
   
    //カテゴリ更新時に確認ウィンドウを表示
    $('#cat_submit').on('click', function() {
        var self_userid = parseInt($('#self_user_id').val());
        var self_roleid = parseInt($('#self_roleid').val());
        var categories = $('#selected_categories option').val();
        var userid = parseInt($('#categories_userid').val());
        if (self_roleid === 5 && categories === undefined && userid  === self_userid){
            alert('自己ユーザのカテゴリを0にすることはできません。');
            return false;
        } else if (self_roleid === 5 && categories === undefined){
            confirm('このままカテゴリを変更すると\n更新対象のユーザがページに表示されなくなります。\nページに表示されないユーザは操作できません。\n更新してもよろしいですか?'); 
        }
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        var form = $('#categories_form');
        var selected_category_ids = $('#selected_category_ids').val();
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'user',
                'action_idx': 'category_change', 
                'user_ids' : JSON.stringify([userid]),
                'category_ids': selected_category_ids
            },
            async: false
        }).done(function(data){
            var message = data['message'];
            if(message.length > 0){
                var conf = confirm(message);
                if(!conf){
                    return false;
                }else{
                    delete data['message'];
                    form.append(
                        $('<input>').attr({'type': 'hidden', 'name': 'categories[rule_info]'}).val(JSON.stringify(data))
                    ).submit();
                }
            }else{
                form.submit();
            }
        });
        
    });
    
     $('#bulk_cat_submit').on('click', function() {
        var self_userid = parseInt($('#self_user_id').val());
        var self_roleid = parseInt($('#self_roleid').val());
        var bulk_categories = $('#bulk_selected_categories option').val();
        var userids = JSON.parse($('#categories_bulk_userids').val());
        if (self_roleid === 5 && bulk_categories === undefined && $.inArray(self_userid, userids) != -1){
            alert('自己ユーザのカテゴリを0にすることはできません。');
            return false;
        } else if (self_roleid === 5 && bulk_categories === undefined){
            return confirm('このままカテゴリを変更すると\n更新対象のユーザがページに表示されなくなります。\nページに表示されないユーザは操作できません。\n更新してもよろしいですか?');
        }
        var path = $('#sidfm_internal_api_check_related_rules_path').val();
        var form = $('#categories_bulk_form');
        var selected_category_ids = $('#bulk_selected_category_ids').val();
        $.ajax({
            url: path,
            type: 'POST',
            data: {
                'page_name': 'user',
                'action_idx': 'bulk_category_change',
                'user_ids' : JSON.stringify(userids),
                'category_ids': selected_category_ids
            },
            async: false
        }).done(function(data){
            var message = data['message'];
            if(message.length > 0){
                var conf = confirm(message);
                if(!conf){
                    return false;
                }else{
                    delete data['message'];
                    form.append(
                        $('<input>').attr({'type': 'hidden', 'name': 'categories_bulk[rule_info]'}).val(JSON.stringify(data))
                    ).submit();
                }
            }else{
                form.submit();
            }
        });
         

    });
    
    //モーダルでのユーザ新規登録・変更処理     
    var funcval;  
    var loginval;
    var fname;
    var lname;
    var emailval;
    var psw;
    var pswconf;
    var authval;
    var auth_text;
    var roleidval;
    var pj_auth_text;
    var mailNotificationVal;
    $('#modal-form').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        var func = button.data('func');
        funcval = func;
        var userid = parseInt(button.data('userid'));
        var title = button.data('title');
        var login = button.data('login');
        loginval = login; 
        var firstname = button.data('firstname');
        fname = firstname;
        var lastname = button.data('lastname');
        lname = lastname;
        var email = button.data('email');
        emailval = email;
        var pw = button.data('pw');
        psw = pw;
        var pwconf = button.data('pwconf');
        pswconf = pwconf;
        var auth = button.data('auth');
        authval = auth;
        var roleid = button.data('roleid');
        roleidval = roleid;
        var redmine_admin = button.data('redmineadmin');
        var mailNotification = button.data('mailnotification').toString();
        mailNotificationVal = mailNotification;
        if (typeof userid === 'undefined' || (userid == "")) {
            userid = '0';
        }
        
        var modal = $(this);
        modal.find('.modal-title .text-truncate').text(title);
        $('#form_userid').val(userid);
        $('#form_login').val(login);
        $('#form_firstname').val(firstname);
        $('#form_lastname').val(lastname);
        $('#form_email').val(email);
        $('#form_pw').val(pw);
        $('#form_pwconf').val(pwconf);
        $('#form_func').val(func);
        $('#mail_notification').val(mailNotification);
        $('#loginlabel').hide();
        $('#user_pwlabel').hide();
        $('#pwlabel').hide();
        $('#lastname_label').hide();
        $('#firstname_label').hide();
        $('#emaillabel').hide();
        if (redmine_admin === true){
            $('#form_sel').prop('disabled', true);
            $('#pj_auth_sel').prop('disabled', true);
        } else {
            $('#form_sel').prop('disabled', false);
            $('#pj_auth_sel').prop('disabled', false);
        }
        $('#form_login').prop('readonly', false);
        $('#form_sel option').prop('selected', false);
        $('#form_sel  option[value="' + auth  + '"]').prop('selected', true);
        var op = $('#pj_auth_sel option[value="-1"]')
        op.text('権限を削除する');
        op.prop('hidden', true);
        op.prop('selected', false);
        $('#pj_auth_sel option[value="' + roleid + '"]').prop('selected', true);
        $('#hidden_auth').prop('disabled', true);
        $('#hidden_pj_auth').prop('disabled', true);
        if ($('#is-view-usr').val() === 'true') {
            $('#form_sel, #pj_auth_sel').prop('disabled', true);
            
        }
        if(login === 'sidfmadm'){
            $('#form_login').prop('readonly', true);
            $('#pj_auth_sel').prop('disabled', true);
        }
        if ($('#form_sel').attr('disabled') != undefined) {
            $('#hidden_auth').prop('disabled', false);
            $('#hidden_auth').val(auth);
        }
        if ($('#pj_auth_sel').attr('disabled') != undefined) {
            $('#hidden_pj_auth').prop('disabled', false);
            $('#hidden_pj_auth').val(roleid);
        }
        if (mailNotification === 'true'){
            $('#mail_notification').prop('checked', true);
        }else{
            $('#mail_notification').prop('checked', false);
        }
        auth_text = $('#form_sel option:selected').text();
        pj_auth_text = $('#pj_auth_sel option:selected').text();   
        $('#form_submit').prop('disabled', true);
        if (func === "new") {
            $('#test-mail-btn').hide();
            $('#form_func').val('new');
            $('#form_submit').val('登録');
            $('#form').attr('action', $('#url_new').val());
        } else {
            set_paginator_parameter("#form_per_page", "#form_filters", "#form_offset", "#form_order")
            $('#form_id').val(userid);
            $('#form_func').val('mod');
            if (userid === parseInt($('#self_user_id').val())){
                op.prop('hidden', true);
                $('#test-mail-btn').show();
            }else{
               op.prop('hidden', false);
               $('#test-mail-btn').hide();
               if (parseInt(roleid) === -1){
                 op.text('必要な場合は選択');
               }
            }
            $('#form_submit').val('更新');
            $('#form').attr('action', $('#url_mod').val());
        }
        
    });
    
    $('#mail_notification').change(function () {
            if($(this).prop('checked')) {
                $(this).val('true');
            }else {
                $(this).val('false');
            }
            btn_status_change();
    });
    $('#form_login').on('input',function(){ 
        if (!$('#form_login').val().match(/^[\x20-\x7e]*$/)){
            $('#loginlabel')
                .text('(半角英数字で入力してください)')
                .show();
        } else {
            $('#loginlabel').hide();
        }
        btn_status_change();
    });

    $('#form_pw').on('input',function() {
        btn_status_change();
        var conf = $('#form_pwconf').val();
        var pw = $(this).val();
        if(conf.length > 0 && conf != pw){
           $('#pwlabel').show();
        }else{
           $('#pwlabel').hide();
        }
    });
 

    $('#form_lastname').on('input',function() {
        btn_status_change();
    });
    
    $('#form_firstname').on('input',function() {
        btn_status_change();
    });

    
    $('#form_pwconf').on('input',function(){
        var conffd = $('#form_pwconf').val();
        var pwfd = $('#form_pw').val(); 
        if ((conffd.length >= pwfd.length) && (conffd != pwfd)) {
            $('#pwlabel').show();
        } else {
            $('#pwlabel').hide();
        }
        btn_status_change();
           
    });
    
    $('#form_email').on('input',function(){
        if (!$('#form_email').val().match(/^[\x20-\x7e]*$/)){
            $('#emaillabel')
                .text('(半角英数字で入力してください)')
                .show();
        } else {
            $('#emaillabel').hide();
        }
        btn_status_change();
    });
  
    $('#mod-body select').change(function() {
        if (funcval != "new"){
            btn_status_change(); 
        }
    });    

    function btn_status_change() {        
        if (funcval != "new") {
            if ($('#form_login').val() != loginval || $('#form_firstname').val() != fname || $('#form_lastname').val() != lname || $('#form_email').val() != emailval || $('#form_pw').val() != psw || $('#form_pwconf').val() != pswconf || $('#form_sel').val() != authval || $('#pj_auth_sel').val() != roleidval || $('#mail_notification').val() != mailNotificationVal) {
               
                $('#form_submit').prop('disabled', false);
            }else{
                $('#form_submit').prop('disabled', true);
            }
        } else {
            if($('#form_login').val() != '' && $('#form_firstname').val() != '' && $('#form_lastname').val() != '' && $('#form_pw').val() != '' && $('#form_pwconf').val() != '' && $('#form_email').val() != ''){
                $('#form_submit').prop('disabled', false);
            } else if($('#form_login').val() === '' || $('#form_firstname').val() === '' || $('#form_lastname').val() === '' || $('#form_pw').val() === '' || $('#form_pwconf').val() === '' || $('#form_email').val() === ''){
                $('#form_submit').prop('disabled', true);
            }  
        }
    } 
       
  //更新ボタン押した後にエラーメッセージを消す処理(入力が空白の時にエラーメッセージを表示するため、入力されたら消す）
    $('#form_lastname').on('input',function (){
    $('#lastname_label').hide();
    });
    $('#form_firstname').on('input',function (){
       $('#firstname_label').hide();
    });
 /*   $('#form_pw').on('input',function (){
       $('#user_pwlabel').hide();
    });*/
     
   
    //submit処理
   $('.form-submit').on('click', function() {
        var func = $('#form_func').val();
        var filtered_mailaddress = $('#form_email').val().replace(/\r?\n/g, '');
        f_err = false;
        if ($('#form_login').val() == '') {
            $('#loginlabel').text('(ログイン名が入力されていません)').show();
            f_err = true;
        }
        if (!$('#form_login').val().match(/^[\x20-\x7e]*$/)){
              f_err = true;
        }
        if ($('#form_lastname').val() == '' || $('#form_firstname').val() == ''){
            if ($('#form_lastname').val() == ''){
                $('#lastname_label').text('(姓が入力されていません)').show();
            }
            if ($('#form_firstname').val() == ''){
                $('#firstname_label').text('(名が入力されていません)').show();
            }
            f_err = true;
        }
        if ($('#form_email').val() == ''){ 
            $('#emaillabel').text('(メールアドレスが入力されていません)').show();
            f_err = true;
        }
        if (!filtered_mailaddress.match(/^([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})$/i)){
            $('#emaillabel').text('(メールアドレスに誤りがあります。)').show();
            f_err = true;
        }
        if ($('#form_login').val().length > 60) {
              $('#loginlabel').text('(ログイン名は60文字以内で入力してください)').show();
              f_err = true;
        }  
        if ($('#form_lastname').val().length > 30) {
              $('#lastname_label').text('(姓は30文字以内で入力してください)').show();
              f_err = true;
        } 
        if ($('#form_firstname').val().length > 30) {
              $('#firstname_label').text('(名は30文字以内で入力してください)').show();
              f_err = true;
        }
        if ((func === 'new') && $('#form_pw').val() == '') {
              $('#user_pwlabel').text('(パスワードを入力してください)').show();
              f_err = true;
        }
        if ($('#form_pw').val() != $('#form_pwconf').val()) {
              $('#user_pwlabel, #pwlabel').text('(パスワードが一致しません)').show();
              f_err = true;
        } 
        if ((func === 'new') && $('#form_pw').val().length < 8) {
              $('#user_pwlabel, #pwlabel').text('(パスワードは8文字以上で入力してください)').show();
              f_err = true;
        } 
        if ((func == 'mod') && $('#form_pw').val().length >= 1 && $('#form_pw').val().length < 8) {
              $('#user_pwlabel, #pwlabel').text('(パスワードは8文字以上で入力してください)').show();
              f_err = true;
        } 
        if ($('#form_login').val().indexOf('/') != -1) {
              $('#loginlabel').text('(ログイン名に「/」は使えません)').show();
              f_err = true;
        }
        if (f_err === true) {
            return false;
        } else {
            if (func === 'mod'){
                var messages = '';
                if ($('#form_login').val() != loginval){ 
                    messages += '「ログイン名」: ' + loginval + ' ⇨ ' + $('#form_login').val() + '\n';}
                if ($('#form_firstname').val() != fname){
                    messages += '「名」: ' + fname + ' ⇨ ' + $('#form_firstname').val() + '\n';}
                if ($('#form_lastname').val() != lname){ 
                    messages += '「姓」: ' + lname + ' ⇨ ' + $('#form_lastname').val() + '\n';}
                if ($('#form_email').val() != emailval){
                    messages += '「メールアドレス」: ' + emailval + ' ⇨ ' + $('#form_email').val() + '\n';}
                if ($('#form_pw').val() != psw){
                    messages += '「パスワード」: 非表示\n';}
                if ($('#form_sel').val() != authval){
                    messages += '「認証方式」: ' + auth_text + ' ⇨ ' + $('#form_sel option:selected').text() + '\n';}
                if ($('#pj_auth_sel').val() != roleidval){
                     messages += '「ユーザ権限」: ' + pj_auth_text + ' ⇨ ' + $('#pj_auth_sel option:selected').text() + '\n';}
                if ($('#mail_notification').val() != mailNotificationVal){
                     var validity = mailNotificationVal == 'true' ? '有効 ⇨ 無効' : '無効 ⇨ 有効';
                     messages += '「メール通知設定」: ' + validity + '\n'}
                return confirm('以下の項目が変更されます。\n' + messages + 'よろしいでしょうか?');
            } else {
                return confirm('登録します。よろしいでしょうか?');
            }
        }      
    });

        
    //ユーザ毎のcheckboxを変更した際の処理
    $('.userSelect').on('change', function() {
        var checkbox = $(this);
        var userid = checkbox.val() - 0;
        var checked = JSON.parse($('#pages_checked').val());
        var all_userids = JSON.parse($('#all_userids').val());
        var all_userids_size = all_userids.length;
        if (checkbox.prop('checked')){
            if (!checked.includes(userid)) {
                checked.push(userid);
                if (checked.length == all_userids_size) {
                    $('.allUserSelect').prop('checked', true);
                    $('#pages_all_checked').val('true');
                } else {
                    $('.allUserSelect').prop('checked', false);
                    $('#pages_all_checked').val('false');
                }
                $('#pages_checked').val(JSON.stringify(checked));
            }
        } else {
            var idx = checked.indexOf(userid);
            if (idx == 0) {
                checked = checked.slice(1, all_userids_size);
            } else if (idx == all_userids_size - 1) {
                checked = checked.slice(0, all_userids_size - 1 );
            } else if (idx > 0) {
                var c_left = checked.slice(0, idx);
                var c_right = checked.slice(idx + 1, all_userids_size);
                checked = c_left.concat(c_right);
            }
            $('#pages_checked').val(JSON.stringify(checked));
            if (checked.length == all_userids_size) {
                $('.allUserSelect').prop('checked', true);
                $('#pages_all_checked').val('true');
            } else {
                $('.allUserSelect').prop('checked', false);
                $('#pages_all_checked').val('false');
            }
        }
        return true;
    });

    //全ユーザチェックのcheckboxの処理
    $('.allUserSelect').on('change', function() {
        var checkbox = $(this);
        if (checkbox.prop('checked')) {
            $('#pages_checked').val($('#all_userids').val());
            $('#pages_all_checked').val('true');
            $('.userSelect').prop('checked', true);
        } else {
            $('#pages_checked').val(JSON.stringify([]));
            $('#pages_all_checked').val('false');
            $('.userSelect').prop('checked', false);
        }
        return true;
    });
    
    //認証方式一括処理
    $('#authenticateBulkModal').on('show.bs.modal', function(event) {
         var button = $(event.relatedTarget);
         make_bulk_data("#authenticate_bulk_userids", "#authenticateBulkTargetList");
         set_paginator_parameter("#authenticate_bulk_per_page", "#authenticate_bulk_filters", "#authenticate_bulk_offset", "#authenticate_bulk_order");
    });
                         
    // ユーザ権限一括処理
    $('#authorityBulkModal').on('show.bs.modal', function(event) {
        var button = $(event.relatedTarget);
        make_bulk_data("#authority_bulk_userids", "#authorityBulkTargetList");
        set_paginator_parameter("#authority_bulk_per_page", "#authority_bulk_filters", "#authority_bulk_offset", "#authority_bulk_order");
     
    });
    // メール通知設定一括処理
    $('#MailNotificationBulkModal').on('show.bs.modal', function(event) {
      make_bulk_data("#mail_notification_bulk_userids", "#MailNotificationBulkTargetList");
      set_paginator_parameter("#mail_notification_bulk_per_page", "#mail_notification_bulk_filters", "#mail_notification_bulk_offset", "#mail_notification_bulk_order");
    });
    
    $('#mail_notification_bulk').change(function () {
        if($(this).prop('checked')) {
            $(this).val('true');
        }else {
            $(this).val('false');
       }
    }); 

    //アクションボタンのmodalを開くとき
    $('.action-btn').on('click', function(){
        var checked = JSON.parse($('#pages_checked').val());
        if(checked.length === 0){
            alert('対象ユーザがチェックされておりません。');
            return false;
        }
        var target_modal = $(this).attr('data-target'); 
        $('#' + target_modal).modal('show');
    });
    
    //一括処理時のテーブル作成処理
    function make_bulk_data(bulk_userids, TargetList) {
        var checked = JSON.parse($('#pages_checked').val());
        var userids_names = JSON.parse($('#all_userids_names').val());
        if (checked.length > 0) {
            $(bulk_userids).val(JSON.stringify(checked));
            $(TargetList + ' > *').remove();
            for (var i = 0; i < checked.length; i++){
                userid = checked[i];
                if (userids_names[userid] != null){
                    var c_tr = $('<tr></tr>', { class: 'list_alternative2' });
                    var c_td = $('<td></td>', { class: 'hostname' });
                    c_td.text(userids_names[userid]);
                    c_tr.append(c_td);
                    $(TargetList).append(c_tr);
                }
            }
        } else {
            alert('対象ユーザがチェックされておりません。');
            location.reload(true);
            return false;
        }
        return true;
        
    } 

    //カテゴリ一括処理
     $('#categoriesBulkModal').on('show.bs.modal', function(event) {
        var button =$(event.relatedTarget);
        make_bulk_data("#categories_bulk_userids", "#categoriesBulkTargetList");
        set_paginator_parameter("#cat_bulk_per_page", "#cat_bulk_filters", "#cat_bulk_offset", "#cat_bulk_order");
        $('#selected_categories > option').remove();
        $('#unselected_categories > option').remove();
  
        return true;
    });

    $('#bulk_select_category').on('click', function() {
        return move_selected_items('#bulk_selected_category_ids',
                                   '#bulk_unselected_categories',
                                   '#bulk_selected_categories', false);
    });

    $('#bulk_unselect_category').on('click', function() {
        return move_selected_items('#bulk_selected_category_ids',
                                   '#bulk_selected_categories',
                                   '#bulk_unselected_categories', true);
    });

    function set_paginator_parameter(p_per_page, p_filters, p_offset, p_order){
        var offset = $('#pages_offset').val();
        var filters = JSON.parse($('#pages_filters').val());
        var per_page = $('#pages_per_page').val();
        var order = $('#pages_order').val();
        $(p_per_page).val(per_page);
        $(p_filters).val(JSON.stringify(filters));
        $(p_offset).val(offset);
        $(p_order).val(order);
    }
    
    $('#TestEmailModal').on('show.bs.modal', function(){
        var email = $('#user_email').val()
        $('#test_email_recipient').text(email);
        $('#hidden_email_address').val(email);
        $('#modal-form').css('z-index','500');
    });
 
    $('#TestEmailModal').on('hidden.bs.modal',function(){
        $('#modal-form').css('z-index', '1050');
    });

  /*  (function() {
        //sticky controll
        window.onscroll = function() { stickyAdd(); };
        var ActionArea = document.getElementById("ActionArea");
        var target = document.getElementById('UsersTable');
        var clientRect = target.getBoundingClientRect();
        var y = clientRect.top; 
        function stickyAdd() {
            if (window.pageYOffset >= y  ) {
                ActionArea.classList.add('sticky');
            } else {
                ActionArea.classList.remove('sticky');                                                                         }
        } 
    })();*/
    sticky_control('UsersTable', 'users');
    $(window).on('load', function() {
        setTimeout(function(){
            set_scroll();
            $(window).on('resize scroll', set_scroll);
        },200);
        $('.modal').on('show.bs.modal', function(){
            $('#floating-scroll').css('z-index', '10');
        });
        $('.modal').on('hidden.bs.modal', function(){
            $('#floating-scroll').css('z-index', '1060');
        });

    });
    
    //ブラウザバックだったらチェックボックスの表示を修正
    $.post($('#check_browser_back_path').val(), {'page_name': 'user'},
        function(info){
            if(info === 'browser_back'){
                var is_all_checked = $('#pages_all_checked').val();
                if(is_all_checked === 'true'){
                    var all_ids = JSON.parse($('#all_userids').val());
                    $('#UsersTable').find('#allSelect, .userSelect').prop('checked', true);
                    $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
                }else{
                    $('#UsersTable').find('#allSelect, .userSelect').prop('checked', false);
                    var pages_checked = JSON.parse($('#pages_checked').val());
                    var target_elm = '';
                    for (var id of pages_checked){
                        target_elm += '#table_selected' + id + ',';
                    }
                    target_elm = target_elm.slice(0, -1);
                    $(target_elm).prop('checked', true);
                }
            }
    });

    //ユーザ削除時に関連するルールをチェック
    $('[data-deluser]').on('click', function(){
      var button = $(this);
      var path = $('#sidfm_internal_api_check_related_rules_path').val();
      var del_user_id = button.attr('data-deluser');
      var form = $('[data-formdel="user_' + del_user_id + '"]');
      $.ajax({
        url: path,
        type: 'POST',
        data: {'page_name': 'user', 'delete_id': del_user_id, 'action_idx': 'delete'},
        async: false
      }).done(function(data){
          var message = data['message'];
          if(message.length > 0){
              var conf = confirm(message);
              if(!conf){
                  return false;
              }else{
                  delete data['message'];
                  form.append(
                      $('<input>').attr({'type': 'hidden', 'name': 'formdel[rule_info]'}).val(JSON.stringify(data))
                  ).submit();
             }
          }else{
              var conf = confirm(button.attr('data-conftext'));
              if(!conf){
                  return false;
              }else{
                  form.submit();
              }
          }
      });

  });

    activate_sidebar_item('sidebar-item-user-manip')     
});
