require_dependency 'user'

module SidfmPatches
  module UserPatch
    extend ActiveSupport::Concern

    included do
      unloadable
      has_and_belongs_to_many :sidfmd_categories
      has_many :sidfmd_rules, dependent: :destroy
      has_many :sidfmd_rule_a_mail_categories, dependent: :destroy, foreign_key: 'from_user_id'
      has_many :sidfmd_rule_a_mail_users, dependent: :destroy
    end
    
  end
end

ActionDispatch::Reloader.to_prepare do
  unless User.included_modules.include?(SidfmPatches::UserPatch)
    User.send(:include, SidfmPatches::UserPatch)
  end
end
