/* coding: utf-8 */
/* Copyright (C) 2018 SofTek Systems, Inc. */

$(function() {

    init_paginator();

    // グラフの描画とリサイズ
    (function() {
	var timer = false;
	var action = function() {
	    if (timer !== false) {
		clearTimeout(timer);
	    }
	    timer = setTimeout(function() {
		var opt = {
		    grp: $('#pages_grp').val(),
		    idx: $('#pages_idx').val(),
		    risks: JSON.parse($('#risks').val()),
		    statuses: JSON.parse($('#statuses').val())
		    
		};
		host_heatmap(opt);
		risk_graph(opt);
		status_graph(opt);
	    }, 200);
	};
	$(window).on('load resize', action);
	$('.navbar-btn').on('click', action);
	// FIXME: 印刷時は、サイズを取得せず固定幅にする
	// $(window).on('beforeprint', action);
    })();

    $('.sort-warning').on('click', sort_toggle('warning'));
    $('.sort-statuses').on('click', sort_toggle('statuses'));
    $('.sort-maxsri').on('click', sort_toggle('maxsri'));
    $('.sort-maxcvss').on('click', sort_toggle('maxcvss'));
    $('.sort-area').on('click', sort_toggle('area'));
    $('.sort-exploitable').on('click', sort_toggle('exploitable'));
    $('.sort-hostname').on('click', sort_toggle('hostname'));
    $('.sort-categories').on('click', sort_toggle('categories'));
    $('.sort-os').on('click', sort_toggle('os'));
    $('.sort-duedates').on('click', sort_toggle('duedates'));
    $('.sort-finished').on('click', sort_toggle('finished'));

    $('.category-selector').text($('#category_name').val());

    $('.category-change').on('click', function() {
	var e = $(this);
	var category_id = e.data('categoryid');
	$('#pages_category_id').val(category_id);
	$('#pages_offset').val('0');
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    (function() {
	$('.grpbtns-change').removeClass('active');
	$('.grpbtns-change > input').prop('checked', false);
	var grp = $('#pages_grp').val();
	if (grp) {
	    $('#grpbtns-' + grp).addClass('active');
	    $('#grpbtns-' + grp + ' > input').prop('checked', true);
	}
	$('.idxbtns-change').removeClass('active');
	$('.idxbtns-change > input').prop('checked', false);
	var idx = $('#pages_idx').val();
	if (idx) {
	    $('#idxbtns-' + idx).addClass('active');
	    $('#idxbtns-' + idx + ' > input').prop('checked', true);
	}
    })();

    $('.grpbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_grp').val(target);
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    $('.idxbtns-change').on('click', function() {
	var button = $(this);
	var target = button.data('target');
	$('#pages_idx').val(target);
	var form = $('#pages_form');
	form.attr('action', remove_anchor(form.attr('action')));
	form.submit();
	return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages').on('click', function(e) {
	var button = $(this);
	var target = $(button.data('target'));
	var dump = {
	    'pages[offset]': $('#pages_offset').val(),
	    'pages[per_page]': $('#pages_per_page').val(),
	    'pages[order]' : $('#pages_order').val(),
	    'pages[filters]': JSON.parse($('#pages_filters').val()),
	    'pages[category_id]': $('#pages_category_id').val(),
	    'pages[grp]': $('#pages_grp').val(),
	    'pages[idx]': $('#pages_idx').val(),
	    'pages[checked]': [],
	    'pages[all_checked]': false
	};
	target.val(JSON.stringify(dump));
	return true;
    });

    // submitする際に、pages_* のパラメータをdata-target=""で指定した箇所に埋め込む。
    // 検索条件を保持して戻れるようにするための細工。
    $('.dump-pages-confirm').on('confirm:complete', function(e, answer) {
	if (answer) {
	    var button = $(this);
	    var target = $(button.data('target'));
	    var dump = {
		'pages[offset]': $('#pages_offset').val(),
		'pages[per_page]': $('#pages_per_page').val(),
		'pages[order]' : $('#pages_order').val(),
		'pages[filters]': JSON.parse($('#pages_filters').val()),
		'pages[category_id]': $('#pages_category_id').val(),
		'pages[grp]': $('#pages_grp').val(),
		'pages[idx]': $('#pages_idx').val(),
		'pages[checked]': [],
		'pages[all_checked]': false
	    };
	    target.val(JSON.stringify(dump));
	}
	return true;
    });

    $('.filter-change').on('click', function() {
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返しており、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-change-exclusion').on('click', function() {
	var link = $(this);
	var name = link.data('name');
	var value = link.data('value');
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sri'] = String('');
	filters['cvss'] = String('');
	filters['area'] = String('');
	filters['exploitable'] = String('');
	filters['os'] = String(':');
	filters['due_date'] = String('::');
	filters['keyword'] = String('');
	filters['date'] = String('::');
	// $('#pages_category_id').val('0');
	$('#pages_offset').val('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	// 強制的に文字列として設定。dataメソッドが、属性値をJSON.parse
	// してから返しており、数値の文字列を数値として解釈しまうため。
	filters[name] = String(value);
	if (name == 'sri' || name == 'cvss') {
	    filters['status'] = String('1:2');
	}
	if (name == 'sri' || name == 'cvss' || name == 'risk' || name == 'area') {
	    filters['warning'] = 'all';
	}
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-date-preset').on('click', function() {
	var button = $(this);
	var begindate = button.data('begindate');
	var enddate = button.data('enddate');
	var inrev = button.data('inrev');

	$('#filters_search_date_begin').val(begindate);
	$('#filters_search_date_end').val(enddate);
	$('#filters_search_date_in_rev').prop('checked', inrev.length > 0);

	return false;
    });


    $('.filter-date').on('click', function(e) {
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	var begindate = $('#filters_search_date_begin').val();
	var enddate = $('#filters_search_date_end').val();
	var inrev = $('#filters_search_date_in_rev').prop('checked');

	var v = (inrev ? 'rev' : 'in') + ':' + begindate + ':' + enddate;
	filters['date'] = String(v);
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();

	return false;
    });

    $('.filter-duedate-preset').on('click', function(e) {
	var button = $(this);
	var begindate = button.data('begindate');
	var enddate = button.data('enddate');
	var notset = button.data('notset');
	$('#filters_search_duedate_begin').val(begindate);
	$('#filters_search_duedate_end').val(enddate);
	$('#filters_search_duedate_notset').prop('checked', ('notset' === notset));
	return false;
    });

    $('.filter-duedate').on('click', function(e) {
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	var begindate = $('#filters_search_duedate_begin').val();
	var enddate = $('#filters_search_duedate_end').val();
	var notset = $('#filters_search_duedate_notset').prop('checked');
	filters['due_date'] = String((notset ? 'notset' : '') + ':' + begindate + ':' + enddate);
	pages_filters.val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-reset').on('click', function(e) {
	var pages_filters = $('#pages_filters');
	var filters = JSON.parse(pages_filters.val());
	filters['due_date'] = '::';
	pages_filters.val(JSON.stringify(filters));
	$('#pages_form').submit();
	return false;
    });

    $('.filter-duedate-notset').on('click', function(e) {
	if ($(this).prop('checked')) {
	    $('#filters_search_duedate_begin').val('');
	    $('#filters_search_duedate_end').val('');
	}
	return true;
    });

    $('.filter-keyword').on('click', function() {
	var filters = JSON.parse($('#pages_filters').val());
	var kwd = $('#filters_search_keyword').val();
	filters['keyword'] = String(kwd);
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-keyword-clear').on('click', function() {
	var filters = JSON.parse($('#pages_filters').val());
	filters['keyword'] = String('');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_offset').val('0');
	$('#pages_form').submit();
	return false;
    });

    $('.filter-clear').on('click', function() {
	var filters = JSON.parse($('#pages_filters').val());
	filters['warning'] = String('all');
	filters['status'] = String('0');
	filters['sri'] = String('');
	filters['cvss'] = String('');
	filters['area'] = String('');
	filters['exploitable'] = String('');
	filters['os'] = String(':');
	filters['due_date'] = String('::');
	filters['keyword'] = String('');
	filters['date'] = String('::');
	$('#pages_category_id').val('0');
	$('#pages_offset').val('0');
	$('#pages_filters').val(JSON.stringify(filters));
	$('#pages_checked').val(JSON.stringify([]));
	$('#pages_all_checked').val('');
	$('#pages_form').submit();
	return false;
    });

    $('.download').on('click', function() {
	$('#download_category_id').val($('#pages_category_id').val());
	$('#download_idx').val($('#pages_idx').val());
	$('#download_order').val($('#pages_order').val());
	$('#download_filters').val($('#pages_filters').val());
	$('#download_hostids').val($('#pages_checked').val());
	$('#form_download').submit();
	return true;
    });

    $('.hostSelect').on('change', function() {
	var checkbox = $(this);
	var hostid = parseInt(checkbox.val());
	var checked = JSON.parse($('#pages_checked').val());
	var all_host_ids = JSON.parse($('#all_host_ids').val());
	var all_host_size = all_host_ids.length;
	if (checkbox.prop('checked')) {
	    if (!checked.includes(hostid)) {
		checked.push(hostid);
		if (checked.length == all_host_size) {
		    $('.allHostSelect').prop('checked', true);
		    $('#pages_all_checked').val('true');
		} else {
		    $('.allHostSelect').prop('checked', false);
		    $('#pages_all_checked').val('');
		}
		$('#pages_checked').val(JSON.stringify(checked));
	    }
	} else {
	    var idx = checked.indexOf(hostid);
	    if (idx == 0) {
		checked = checked.slice(1, all_host_size);
	    } else if (idx == all_host_size - 1) {
		checked = checked.slice(0, all_host_size - 1);
	    } else if (idx > 0 ) {
		var c_left = checked.slice(0, idx);
		var c_right = checked.slice(idx + 1, all_host_size);
		checked = c_left.concat(c_right);
	    }
	    $('#pages_checked').val(JSON.stringify(checked));
	    if (checked.length == all_host_size) {
		$('.allHostSelect').prop('checked', true);
		$('#pages_all_checked').val('true');
	    } else {
		$('.allHostSelect').prop('checked', false);
		$('#pages_all_checked').val('');
	    }
	}
	if (checked.length > 0) {
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    $('.allHostSelect').on('change', function() {
	var checkbox = $(this);
	if (checkbox.prop('checked')) {
      var filtered_hostids = JSON.parse($('#all_host_ids').val()).filter(Boolean); 
	    $('#pages_checked').val(JSON.stringify(filtered_hostids));
	    $('#pages_all_checked').val('true');
	    $(".hostSelect[disabled!='disabled']").prop('checked', true);
	    $('.bulkbtns').removeClass('disabled');
	    $('.bulkbtns').prop('disabled', false);
	} else {
	    $('#pages_checked').val(JSON.stringify([]));
	    $('#pages_all_checked').val('');
	    $(".hostSelect[disabled!='disabled']").prop('checked', false);
	    $('.bulkbtns').addClass('disabled');
	    $('.bulkbtns').prop('disabled', true);
	}
	return true;
    });

    $('#modalEditStatus').on('show.bs.modal', function(event) {
	var submit_button = $('#modalEditStatusExecute');
	submit_button.prop('disabled', true);
	submit_button.attr('aria-disabled', 'true');
	var button = $(event.relatedTarget);
	var hostids = JSON.parse($('#pages_checked').val());
	if (hostids.length > 0) {
	    $.ajax({
		url: $('#hosts_statuses_path').val(),
		type: 'POST',
		dataType: 'json',
		data: { 'params[hostids]': JSON.stringify(hostids) },
		timeout: 5000
	    })
	    .done(function(data) {
		var hosts = data['hosts'];
		var issues = data['issues'];
		var statuses = data['statuses'];
		$('#modalEditStatusTargetList > *').remove();
		if (hosts.length > 0) {
		    for (var i = 0; i < hosts.length; i++) {
			var c_tr = $('<tr></tr>').attr('class', 'd-flex');
			var c_td = $('<td></td>', {
			    class: 'd-block modal-t-name'//'hostname'
			});
			c_td.text(hosts[i]['hostname']);
			c_tr.append(c_td);
			c_td = $('<td></td>').attr('class', 'd-block modal-t-status');
			var c_span = $('<span></span>', {
			    class: 'badge g-font-size-11 c_white'
			});
      if(i === 0){
          var svg = status_bar(70, 12, statuses[hosts[i]['id']], '件');
          svg.find('a').data('placement', 'left');
          c_span.append(svg);
      }else{
          c_span.append(status_bar(70, 12, statuses[hosts[i]['id']], '件'));
      }
			c_td.append(c_span);
			c_tr.append(c_td);
			$('#modalEditStatusTargetList').append(c_tr);
		    }
		    enable_bootstrap_actions('#modalEditStatusTargetList');
		    $('#modalEditStatusNotice > *').remove();
		    $('#modalEditStatus_hostids').val(JSON.stringify(hostids));
		} else {
		    alert('指定したホストが削除されたため、画面をリロードします。');
		    location.reload(true);
		    return false;
		}
	    })
	    .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    })
	} else {
	    return false;
	}
	return true;
    });

    $('#modalEditStatusSelect').on('change', function(event) {
	var target = $(this);
	var new_val = target.val();
	var button = $('#modalEditStatusExecute');
	if ('0' == new_val) {
	    button.prop('disabled', true);
	    button.attr('aria-disabled', 'true');
	} else {
	    button.prop('disabled', false);
	    button.attr('aria-disabled', 'false');
	}
	return true;
    });

    $('#modalEditSchedule').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var hostids = JSON.parse($('#pages_checked').val());
	if (hostids.length > 0) {
	    $.ajax({
		url: $('#hosts_due_dates_path').val(),
		type: 'POST',
		dataType: 'json',
		data: { 'params[hostids]': JSON.stringify(hostids) },
		timeout: 5000
	    })
	    .done(function(data) {
		var hosts = data['hosts'];
		var issues = data['issues'];
		$('#modalEditScheduleTargetList > *').remove();
		if (hosts.length > 0) {
		    for (var i = 0; i < hosts.length; i++) {
			var c_tr = $('<tr></tr>').attr('class', 'd-flex');
			var c_td = $('<td></td>').attr('class', 'd-block modal-t-name');// { class: 'hostname' });
			c_td.text(hosts[i]['hostname'])
			c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'd-block modal-t-date'});
			var due_dates = [];
			for (var j = 0; j < issues.length; j++) {
			    if (hosts[i]['id'] == issues[j]['sidfmd_host_id']) {
				if (issues[j]['due_date']) {
				    if (!due_dates.includes(issues[j]['due_date'])) {
					due_dates.push(issues[j]['due_date']);
				    }
				} else {
				    if (!due_dates.includes('未設定')) {
					due_dates.push('未設定');
				    }
				}
			    }
			}
			due_dates.sort();
			for (var j = 0; j < due_dates.length; j++) {
			    var c_div = $('<div></div>');
			    c_div.text(due_dates[j]);
			    c_td.append(c_div);
			}
			c_tr.append(c_td);
			$('#modalEditScheduleTargetList').append(c_tr);
		     }
		    $('#modalEditScheduleNotice > *').remove();
		    $('#modalEditScheduleExecute').prop('disabled', false);
		    $('#modalEditSchedule_hostids').val(JSON.stringify(hostids));
		} else {
		    alert('指定したホストが削除されたため、画面をリロードします。');
		    location.reload(true);
		    return false;
		}
	    })
	    .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    })
	} else {
	    return false;
	}
	return true;
    });
 
    function get_popover_btn(names_array, userid, type){
        var elms_for_popover = '';
        for(var j = 0; j < names_array.length; j++){
            elms_for_popover += '<div class="p-1 max-width-160px g-font-size-0_93x text-left text-truncate border list_alternative">' + names_array[j] + '</div>';
        }
        var popover_btn = $('<div>').attr({
                              'class': 'max-width-160px',
                           }).append(
                               $('<div>').attr({
                                   'class': ' mail-btn show-original-popover btn btn-xs btn-light-nb text-nowrap w-100',
                                   'data-popoverid': type + userid,
                                   'data-html': 'true',
                                   'data-content': elms_for_popover,
                               }).append(
                                   $('<div>').attr('class', 'd-flex').append(
                                       $('<span>').attr('class', 'text-left mr-1 inline-block text-truncate w-100')
                                                  .text(names_array[0]),
                                       $('<span>').attr('class', 'position-static ml-auto inline-block badge badge-pill badge-gray-999')
                                                  .text(names_array.length)
                                   )
                               )
                           );
        return popover_btn
    }
     
    $('#modalSendMail').on('show.bs.modal', function(event) {
	var button = $(event.relatedTarget);
	var hostids = JSON.parse($('#pages_checked').val());
  $('#recipients').val(JSON.stringify({}));
  $('#users_sidinfo').val(JSON.stringify([]));
  $('#AllUsersSelect').prop('checked', false);
  $('#count-letters').text('0');
  revert_changekeywords_btn();
  $('#mail-length-over').attr('class', 'invisible');
  $('#limit-keywords-data').text('20件');
  $('#limit-data-num').val(20);
  $('#show-byte').text('byte');
  $('#keyword_loading').remove();
  $('#modalSendMailTargetList .chk-box .user-chk-box').prop('checked', false);
	if (hostids.length > 0) {
	    $.ajax({
		url: $('#hosts_categories_users_emails_path').val(),
		type: 'POST',
		dataType: 'json',
		data: { 'params[hostids]': JSON.stringify(hostids) },
		timeout: 5000
	    })
	    .done(function(data) {
		var hosts = data['hosts'];
		var categories = data['categories'];
		var categories_hosts = data['categories_hosts'];
		var categories_users = data['categories_users'];
		var users = data['users'];
		var emails = data['emails'];
    if(users.length === 0){
        $('#AllUsersSelect').prop('disabled', true);
    } else {
        $('#AllUsersSelect').prop('disabled', false);
    }
    users = users.sort(function(a, b) {
            if(a['lastname'].toString().toLowerCase() > b['lastname'].toString().toLowerCase()){
                return 1;
             }else if(a['lastname'].toString().toLowerCase() === b['lastname'].toString().toLowerCase()){
                 if(a['firstname'].toString().toLowerCase() > b['firstname'].toString().toLowerCase()){
                     return 1;
                 } else {
                     return -1;
                 }
             }else{ 
                 return -1;
             }
             });
    var all_users ={};
    var users_sidinfo = [];
    var user_num = 0;
		$('#modalSendMailTargetList > *').remove();
		if (emails.length > 0) {
		    for (var i = 0; i < users.length; i++) {
      user_num += 1;
      var fullname = users[i]['lastname'] + ' ' + users[i]['firstname'];
			var c_tr = $('<tr></tr>').attr('class', '');
      var c_td = $('<td></td>', { class: 'chk-box modal-mail-chkbox text-center' });
      var c_chkbox = $('<input>', { type: 'checkbox', class: 'user-chk-box'});
      c_td.append(c_chkbox);
      c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'name modal-mail-name' });
	    c_td.text(fullname);
			c_tr.append(c_td);
			c_td = $('<td></td>', { class: 'mailaddress modal-mail-address' });
			for (var j = 0; j < emails.length; j++) {
			    if (users[i]['id'] == emails[j]['user_id']) {
				var c_div = $('<div class="text-truncate modal-mail-address"></div>');
				c_div.text(emails[j]['address']);
				c_td.append(c_div);
        all_users[emails[j]['address']] = fullname;
			    }
			}
			c_tr.append(c_td);
			var temp_cats = [];
			for (var j = 0; j < categories_users.length; j++) {
			    if (users[i]['id'] == categories_users[j]['user_id']) {
				var temp = categories_users[j]['sidfmd_category_id'];
				if (!temp_cats.includes(temp)) {

				    temp_cats.push(temp);
				}
			    }
			}
			c_td = $('<td></td>', { class: 'category modal-mail-category' });
      var category_names = [];
			for (var j = 0; j < temp_cats.length; j++) {
			    for (var k = 0; k < categories.length; k++) {
				if (temp_cats[j] == categories[k]['id']) {
				 //   var c_div = $('<div class="text-truncate modal-mail-category"></div>');
				    category_names.push(categories[k]['name'])
				  /*  c_div.text(categories[k]['name']);
				    c_td.append(c_div);*/
				}
			    }
			}
      if(category_names.length > 1){
          category_names.sort();
          var categories_elm = get_popover_btn(category_names, users[i]['id'], 'category');
      }else{
          var categories_elm = $('<div>').attr('class', 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px').text(category_names[0]);
      }
      c_td.append(categories_elm);
			c_tr.append(c_td);
			var temp_hosts = [];
      var temp_hostnames = [];
			for (var j = 0; j < hosts.length; j++) {
			    for (var k = 0; k < temp_cats.length; k++) {
				for (var l = 0; l < categories_hosts.length; l++) {
				    if (hosts[j]['id'] == categories_hosts[l]['sidfmd_host_id'] && temp_cats[k] == categories_hosts[l]['sidfmd_category_id']) {
					if (!temp_hosts.includes(hosts[j])) {
					    temp_hosts.push(hosts[j]);
					}
				    }
				}
			    }
			}
			c_td = $('<td></td>', { class: 'host modal-mail-host' });
			for (var j = 0; j < temp_hosts.length; j++) {
			   /* var c_div = $('<div class="text-truncate modal-mail-host"></div>');
			    c_div.text(temp_hosts[j]['hostname']);
			    c_td.append(c_div);*/
          temp_hostnames.push(temp_hosts[j]['hostname']);
			}
      if(temp_hostnames.length > 1){
          temp_hostnames.sort();
          var hosts_elm = get_popover_btn(temp_hostnames, users[i]['id'], 'host');
      }else{
          var hosts_elm = $('<div>').attr('class', 'g-pl-5 g-font-size-0_93x text-truncate max-width-160px').text(temp_hostnames[0]);
      }
      c_td.append(hosts_elm);
			c_tr.append(c_td);
      var userinfo = {'num': user_num, 'category_names': category_names, 'hostnames': temp_hostnames};
      c_chkbox.val(JSON.stringify(userinfo));
      users_sidinfo.push(userinfo);
			$('#modalSendMailTargetList').append(c_tr);
		    }
		  $('#modalSendMailNotice > *').remove();

      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      $('#modalSendmailExecute').prop('disabled', true);
      $('#MailConfirmation-btn').prop('disabled', true);
      $('#keywords-list').prop('disabled', false);
      $('#change-keywords').prop('disabled', false);
      $('#limit-keywords-data').prop('disabled', false);
      $('#reset-mailmodal').prop('disabled', false);
      var chk_box_length = $('#modalSendMailTargetList .user-chk-box').length;
      $('#modalSendMailTargetList .chk-box .user-chk-box').on('change', function() {
          var checkbox = $(this);
          var user_info = JSON.parse(checkbox.val());
          var temp_users_sidinfo = JSON.parse($('#users_sidinfo').val());
          var recipients = JSON.parse($('#recipients').val());
          var user_address = checkbox.parent().siblings('.mailaddress').text();
          var user_name = checkbox.parent().siblings('.name').text();
          if (checkbox.prop('checked')) {
              temp_users_sidinfo.push(user_info);
              recipients[user_address] = user_name;
          }else{
              for(var i = 0; i < temp_users_sidinfo.length; i++){
                  if(temp_users_sidinfo[i]['num'] === user_info['num']){
                      temp_users_sidinfo.splice(i, 1);
                  }
              }
              delete recipients[user_address];
          }
          if (Object.keys(recipients).length === chk_box_length){
              $('#AllUsersSelect').prop('checked', true);
          }else{
              $('#AllUsersSelect').prop('checked', false);
          }
          if($('.user-chk-box:checked').length === 0){
              $('#modalSendmailExecute').prop('disabled', true);
          }else{
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
                  $('#modalSendmailExecute').prop('disabled', false);
              }
          }
          $('#recipients').val(JSON.stringify(recipients));
          $('#users_sidinfo').val(JSON.stringify(temp_users_sidinfo));
      });
      $('#AllUsersSelect').on('change', function (){
          var all_chk_box = $('#modalSendMailTargetList .user-chk-box');
          if ($(this).prop('checked')) {
              all_chk_box.prop('checked', true);
              $('#recipients').val(JSON.stringify(all_users));
              $('#users_sidinfo').val(JSON.stringify(users_sidinfo));
              if($('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
                  $('#modalSendmailExecute').prop('disabled', false);
              }
          }else{
              all_chk_box.prop('checked', false);
              $('#recipients').val(JSON.stringify({}));
              $('#users_sidinfo').val(JSON.stringify([]));
              $('#modalSendmailExecute').prop('disabled', true);
          }
      }); 
      //EnterキーでSubmitされるのを防ぐ
      $('#modalSendmailBodyTitle').on('keydown', function(e) {
          if(e.keyCode && e.keyCode === 13){
              return false;
          }
      });
      $('#modalSendMail').on('hide.bs.modal', function (){
         $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();      
         // edited_title = $('#modalSendmailBodyTitle').val();
         // edited_text = $('#modalSendmailBodyText').val();
      }); 
      
      // tableのcss設定中は表示見せない
      //$('#modalSendMailTargetList').css('opacity', '0.05');
 
      set_modal_mail_btn_font_size();
      
		} else {
		    var temp = $('<div></div>');
		    temp.attr('class', 'alert alert-danger');
		    temp.attr('role', 'alert');
		    temp.text('指定したホストに、メール送信可能なユーザが関連付けられたカテゴリが設定されておりません。メール送信を行うためには、ユーザを関連づけたカテゴリを作成し、各ホストのカテゴリとして追加登録する必要があります。');
		    $('#modalSendMailNotice > *').remove();
		    $('#modalSendMailNotice').append(temp);
        $('#modalSendmailBodyTitle').val('');
        $('#modalSendmailBodyText').val('');
        $('#keywords-list').prop('disabled', true);
		    $('#modalSendmailExecute').prop('disabled', true);
        $('#MailConfirmation-btn').prop('disabled', true);
        $('#change-keywords').prop('disabled', true);
        $('#limit-keywords-data').prop('disabled', true);
        $('#reset-mailmodal').prop('disabled', true);
		}
 	    })
            .fail(function(data) {
		alert('データの取得に失敗したため、画面をリロードします。');
		location.reload(true);
		return false;
	    });
	} else {
	    return false;
	}
	return true;
    });

    (function() {
	var filters = JSON.parse($('#pages_filters').val());
	if (filters['warning'] == 'warning') {
	    activate_sidebar_item('sidebar-item-warninghosts');
	} else {
	    activate_sidebar_item('sidebar-item-hosts');
	}
    })();
  $('#modalSendmailBodyText, #modalSendmailBodyTitle').on('input', function(){
      if($('#change-keywords').text() === 'キーワードに戻す'){
          revert_changekeywords_btn();
      }
      check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
      if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
  });

  $('#modalSendMail').on('shown.bs.modal',function(){
      //heightを設定してロードマーク表示時に崩れないようにする
      $('#LoadingTarget').height($('#change-keywords').height());
  });
//  var timer = setInterval(function(){
//      if($('#modalSendMailTargetList').css('opacity') === '0.05'){
//          $('#modalSendMailTargetList').find('tr').each(function(){
//              var tr = $(this);
//              var tr_height = $(this).height();
//              var box = tr.find('.chk-box');
//              var name = tr.find('.name');
//              var addr = tr.find('.mailaddress');
//              var category = tr.find('.category');
//              var host = tr.find('.host');
//              var b_height = box.height();
//              var n_height = name.height();
//              var ad_height = addr.height();
//              var c_height = 0;
//              var h_height = 0;
//              category.find('.cat-item').each(function(){
//                  c_height += $(this).height();
//             });
//             host.find('.host-item').each(function(){
//                  h_height += $(this).height();
//              });
//              var h = (tr_height - b_height) / 2;
//              box.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - n_height) / 2;
//              name.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - ad_height) / 2;
//              addr.css({'cssText': 'padding-top:' +  h + 'px !important;'});
//              h = (tr_height - c_height) / 2;
//              category.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              h = (tr_height - h_height) / 2;
//              host.css({'cssText': 'padding-top:' + h + 'px !important;'});
//              // tdのheight100%を設定するためにcssに高さを伝える
//              $(this).height($(this).height());
//          });
//          $('#modalSendMailTargetList').css('opacity', '');
//          clearInterval(timer);
//      }
//  },100);
//});

  function set_modal_mail_btn_font_size(){
      if($(window).width() < 992){
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '75%');
      }else{
          $('#modalSendMail').find('.modal-mail-footer-part').css('font-size', '');
      }
  }

  $(window).on('resize', set_modal_mail_btn_font_size);

/*  var edited_text;
  var edited_title;*/
  function revert_changekeywords_btn() {
      $('#change-keywords').text('キーワードを変換')
                           .attr('class', 'btn btn-light btn-sm text-nowrap')
                           .data('replace', 'replace')
                           .css('color', 'black');
  }
  function change_changekeywords_btn(){
       $('#change-keywords').text('キーワードに戻す')
                            .attr('class', 'btn btn-secondary btn-sm text-nowrap')
                            .data('replace', 'revert')
                            .css('color', 'white');
  }
  $('#modalSendmailExecute').on('click', function(){
      if($('#modalSendmailBodyTitle').val().length === 0){
          alert('件名を入力して下さい');
          return false;
      }
      if($('#modalSendmailBodyText').val().length ===0){
          alert('本文を入力して下さい');
          return false;
      }
  });
   $('#mail-cancel, #close-mailmodal').on('click', function(){
       if($('#modalSendmailBodyText').val() != '' || $('#modalSendmailBodyTitle').val() != ''){
           return confirm('メールの内容は破棄されます。よろしいですか？');
       }
   });
  $('#MailConfirmation').on('hide.bs.modal', function(){
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      check_mail_length($('#confirm-message').val() + $('#confirm-subject').text());
  });
  $('#MailConfirmation').on('show.bs.modal', function (e){
     
      $('#confirm-recipients > *').remove();
      var recipients = JSON.parse($('#recipients').val());
      $.each(recipients, function( address, name) {
         var recipient_text = name + '<' + address + '>';
         var recipient = $('<tr><td></td></tr>');
         recipient.text(recipient_text);
         $('#confirm-recipients').append(recipient);
      });
      var mailcontent = replace_mail_keywords('#confirm-subject', '#confirm-message');
      if(mailcontent != 'nochange'){
           change_changekeywords_btn();
          before_replaced = mailcontent;
      }
      var bytes = calc_bytes($('#confirm-message').val() + $('#confirm-subject').text());
      if(bytes > 1048576){
          $('#warn-length-over').attr('class', 'ml-auto visible');
          $('#MailConfirmationSubmit').prop('disabled', true);
      }else{
          $('#warn-length-over').attr('class', 'ml-auto invisible');
          $('#MailConfirmationSubmit').prop('disabled', false);
      }
  });
  var myuserinfo = JSON.parse($('#myuserinfo').val());
  var myusername = myuserinfo['name'];
  var myemail = myuserinfo['email'];
  var mylogin = myuserinfo['login'];
  var URL = location.href.replace(/index_r/, 'index');
  var page_title = $('#sidfm_header_title').text();
  var unhandled_rate = $('#unhandled_rate').val() + '%';
  var risks = JSON.parse($('#number_of_risks').val());
  var risks_text;
  var risks_names;
  var nums;
  if (risks['sri']){
      risks_names = ['重大', '高', '中', '低', '無'];
      nums = risks['sri'];
  }else if (risks['cvss']){
      nums = risks['cvss'];
      risks_names = ['未登録', ' 10.0～9.0', ' 8.9～7.0', ' 6.9～4.0', ' 3.9～0.0'];
  }
  calculate_percentage(nums, risks_names, 'risks');
  var status_text;
  var status_nums = JSON.parse($('#number_of_status').val());
  var all_area = ['未定義 ', 'ローカル ', 'クライント ', 'リモート '];
  var all_status_names = [' 未対策', ' 対策中', ' 対策済', ' 影響無'];
  var all_sri_status = ['無', '低', '中', '高', '重大'];
  calculate_percentage(status_nums, all_status_names, 'status');
  function calculate_percentage(numbers, labelnames, section){
      var sum = 0;
      var text = [];
      for (var i = 0; i < numbers.length; i++){
          sum += parseInt(numbers[i]);
      }
      for (var i = 0; i < labelnames.length; i++){
          var num = parseInt(numbers[i]);
          var percentage = (num / sum * 100).toFixed(3);
          if(percentage >= 10){
              percentage = (num / sum * 100).toFixed(1);
          } else if(percentage < 10 && percentage >= 1) {
              percentage = (num / sum * 100).toFixed(2);
          }
          percentage = parseFloat(percentage) + '%';
          text.push(labelnames[i] + ': ' + percentage);
      }
      if(section === 'risks'){
          risks_text = text;
      } else {
          status_text = text;
      }
  }
  function replace_mail_keywords(subject_field, message_field){
     // $('#keyword-btn').attr('class', '_loading mx-auto pr-0');//('class', '_loading mx-auto col pr-0');
      var limit_num = parseInt($('#limit-data-num').val());
      var checked = JSON.parse($('#pages_checked').val());
      var hostnames_list = [];
      var c_category_list = [];
      var s_category_list = [];
      var osnames_list = [];
      var selected_users = [];
      var recipients_sidinfo = JSON.parse($('#users_sidinfo').val());
      var recipients_hostnames = [];
      var recipients_categories = [];
      for(var i = 0; i < recipients_sidinfo.length; i++){
          var info = recipients_sidinfo[i];
          recipients_hostnames.push(info['hostnames']);
          recipients_categories.push(info['category_names']);
      }
      recipients_hostnames = Array.prototype.concat.apply([], recipients_hostnames);
      recipients_categories = Array.prototype.concat.apply([], recipients_categories);
      var self_categories = JSON.parse($('#self_user_categories').val());
      var self_custom_category_names = [];
      var self_system_category_names = [];
      for(var i = 0; i < self_categories.length; i++){
          var c = self_categories[i];
          if(c['custom_c']){
              self_custom_category_names.push(c['custom_c']);
          }else if(c['system_c']){
              self_system_category_names.push(c['system_c']);
          }
      }
      var hosts_info_list = [];
      var risks_rate = risks_text.join(',');
      var handling_rate = status_text.join(',');
      var links_to_hostdetail = [];
      var host_selectors = [];
     var count = 0;
     var subject_val = $('#modalSendmailBodyTitle').val();
     var message_val = $('#modalSendmailBodyText').val();
     $.each(checked, function(){   
          var host = $('#hostid' + parseInt(this));
          var hostid = host.data('hostid');
          var hostname = host.data('hostname');
          hostnames_list.push(hostname);
          var osname = host.data('osname');
          osnames_list.push(osname);
          var c_cat = host.data('customcategory');
          var s_cat = host.data('systemcategory');
          if(s_cat != 'none'){
               s_category_list.push(s_cat);
          }
          if(c_cat.length > 0){
              c_category_list.push(...c_cat);
          }
          if(count < limit_num){
              var link = location.origin + url_host_detail(hostid);
              var link_with_hostname = hostname + '\n' + link;
              links_to_hostdetail.push(link_with_hostname);
          }
          if(subject_val.indexOf('%HOSTINFO%') != -1 || message_val.indexOf('%HOSTINFO%') != -1){
          if(count < limit_num){
             var areaid = host.data('areaid');
             var area = all_area[areaid];
             var status_ids = host.data('statusids');
             var noreg = 0;
             var local = 0;
             var client = 0;
             var remote = 0;
             var status_nums = [noreg, local, client, remote];
             for(var i = 0; i < status_ids.length; i++){
                 var status_id = status_ids[i] - 1;
                 status_nums[status_id] += 1;
             }
             var h_status = '';
             for(var i = 0; i < all_status_names.length; i++){
                 h_status += all_status_names[i] + status_nums[i] + '件 ';
             }
             var sri_id = host.data('sri');
             var sri = all_sri_status[sri_id];
             var cvss = host.data('cvss');
             var exploit = host.data('exploit');
             var osname = host.data('osname');
             var t_date = host.data('tackledate');
             var t_status = host.data('tacklestatus');
             var taiou = host.data('taiou'); 
             var c_cat = host.data('customcategory');
             var s_cat = host.data('systemcategory');
             if(s_cat === 'none'){
                 s_cat = 'なし';
             }
             if(c_cat.length > 0){
                 c_cat = c_cat.join(', ');
             }else{
                 c_cat = 'なし';
             }
             var text = [ hostname,link, 'OS:' + osname, 'システムカテゴリ:' + s_cat + '   ' + 'カスタムカテゴリ:' + c_cat, '対応:' + taiou + '   ' +  '最大SRI値:' + sri + '   ' + '最大CVSS値:' + cvss + '   ' +  '影響範囲:' + area + '   ' + '攻撃コード:' + exploit, '対応状況:' + h_status, '対策予定日設定済:' + t_date + '   ' + '対処率:' + t_status];
              hosts_info_list.push(text.join('\n'));
          }
          }
          count += 1;
      });
      hostnames_list = Array.from(new Set(hostnames_list));
      c_category_list = Array.from(new Set(c_category_list));
      s_category_list = Array.from(new Set(s_category_list));
      osnames_list = Array.from(new Set(osnames_list));
      recipients_categories = Array.from(new Set(recipients_categories));
      recipients_hostnames = Array.from(new Set(recipients_hostnames));

      var u_checked  = JSON.parse($('#recipients').val());
      for (key in u_checked){
          selected_users.push(u_checked[key]);
      } 
      hostnames_list = hostnames_list.slice(0, limit_num);
      c_category_list = c_category_list.slice(0, limit_num);
      s_category_list = s_category_list.slice(0, limit_num);
      osnames_list = osnames_list.slice(0, limit_num);
      recipients_categories = recipients_categories.slice(0, limit_num);
      recipients_hostnames = recipients_hostnames.slice(0, limit_num);
      selected_users = selected_users.slice(0, limit_num);
      self_system_category_names = self_system_category_names.slice(0, limit_num);
      self_custom_category_names = self_custom_category_names.slice(0, limit_num);

      var message = $('#modalSendmailBodyText').val();
    //  edited_text = message;
      function replace_keywords(text) {
          var replaced_text =
          text.replace(/%HOST%/, hostnames_list.join(', '))
              .replace(/%C_CATEGORY%/, c_category_list.length > 0 ? c_category_list.join(', ') : 'なし')
              .replace(/%S_CATEGORY%/, s_category_list.length > 0 ? s_category_list.join(', ') : 'なし')
              .replace(/%OS%/, osnames_list.join(', '))
              .replace(/%LINKS%/, links_to_hostdetail.join(',\n'))
              .replace(/%URL%/g, URL)
              .replace(/%NAME%/, selected_users.join(', '))
              .replace(/%TITLE%/g, page_title)
              .replace(/%UNHANDLED_RATE%/g, unhandled_rate)
              .replace(/%RISK_RATE%/g, risks_rate)
              .replace(/%HANDLING_RATE%/g, handling_rate)
              .replace(/%HOSTINFO%/, hosts_info_list.join('\n\n'))
              .replace(/%MYNAME%/g, myusername)
              .replace(/%MY_USER_NAME%/g, mylogin)
              .replace(/%MYEMAIL%/g, myemail)
              .replace(/%R_HOSTNAME%/, recipients_hostnames.join(', '))
              .replace(/%R_CATEGORY%/, recipients_categories.join(', '))
              .replace(/%MY_S_CATEGORY%/g, self_system_category_names.length > 0 ? self_system_category_names.join(', ') : 'システムカテゴリ無し')
              .replace(/%MY_C_CATEGORY%/g, self_custom_category_names.length > 0 ? self_custom_category_names.join(', ') : 'カスタムカテゴリ無し')
              ;
          return replaced_text;
      }
      var replaced_message = replace_keywords(message);
      var subject = $('#modalSendmailBodyTitle').val();
      var replaced_subject = replace_keywords(subject);
      if(subject_field === '#modalSendmailBodyTitle'){
          $(subject_field).val(replaced_subject);
      }else{
          $(subject_field).text(replaced_subject);
      }
      $(message_field).val(replaced_message);
     // $('#keyword-btn').attr('class', 'dropup d-inline-block pr-0');//('class', 'dropup col pr-0');

      if(message === replaced_message && subject === replaced_subject){
          return 'nochange';
      }else{
          return {'subject': subject, 'message': message};
      } 
  }
  var before_replaced;
  $('#LoadingTarget').on('click', function(){
      if($('.action-close-dropdown').is(':visible')){
          $('#keywords-list').dropdown('toggle');
      }
      if($('#limit-data-num').val() >= 500 && $('#change-keywords').data('replace') === 'replace'){
          var target_offset = $('#LoadingTarget').offset();
          var target_top = target_offset.top;
          var target_left = target_offset.left;
          var keyword_loading = $('<div>').attr('id', 'keyword_loading');
          var hidden_loading = $('<div>').attr({
                                             'id': 'hidden_loading',
                                             'class': '_loading mx-auto',
                                             'style': 'display:none;height:20;'
                                         });
          keyword_loading.append(hidden_loading);
          $(this).append(keyword_loading);
          $('#keyword_loading').offset({
             top: target_top -15,
             left: target_left
          });
          $('#hidden_loading').show(adjust_btn_status);
      }else{
          adjust_btn_status();
      }
  });
  function adjust_btn_status(){
      var btn =  $('#change-keywords');
      if(btn.data('replace') === 'replace'){
          before_replaced = replace_mail_keywords('#modalSendmailBodyTitle', '#modalSendmailBodyText');
          if(before_replaced != 'nochange'){
              change_changekeywords_btn();
          }else{
              btn.tooltip('show');
              setTimeout(function(){
                  btn.tooltip('hide');
              }, 1000);
          }
      }else{
          if(before_replaced != null){
              revert_changekeywords_btn();
              $('#modalSendmailBodyTitle').val(before_replaced['subject']);
              $('#modalSendmailBodyText').val(before_replaced['message']);
          }
      }
      check_mail_length($('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val());
      $('#keyword_loading').remove();
  }
  $(document).on('click', '#MailConfirmationSubmit', function(){
      $('#modalSendmailBodyText').val($('#confirm-message').val());
      $('#modalSendmailBodyTitle').val($('#confirm-subject').text());
      $('#MailConfirmation').modal('hide');
      $('#modalSendMail').modal('hide');
      $('#form_sendmails').submit();
  });
  var selected_textarea = $('#modalSendmailBodyText');
  $('#modalSendmailBodyTitle, #modalSendmailBodyText').on('click', function (){
      selected_textarea = $(this);
  });
  $('.put-keyword').on('click', function (){
      var textarea = selected_textarea;
      var pos = textarea.get(0).selectionStart;
      var len = textarea.val().length;
      var content =  textarea.val();
      var before = content.substr(0, pos);
      var keyword = $(this).val();
      var after = content.substr(pos);
      content = before + keyword + after;
      textarea.val(content);
      revert_changekeywords_btn();
      var sum_mail_letters = $('#modalSendmailBodyText').val() + $('#modalSendmailBodyTitle').val();
      check_mail_length(sum_mail_letters);
      if($('#recipients').val() != '{}' && $('#modalSendmailBodyText').val() != '' && $('#modalSendmailBodyTitle').val() != ''){
          $('#modalSendmailExecute').prop('disabled', false);
      }else{
          $('#modalSendmailExecute').prop('disabled', true);
      }
  });
  $('#reset-mailmodal').on('click', function(){
      $('#AllUsersSelect').prop('checked', false);
      $('.user-chk-box').prop('checked', false);
      $('#recipients').val(JSON.stringify({}));
      $('#modalSendmailBodyTitle').val('');
      $('#modalSendmailBodyText').val('');
      check_mail_length('');
      revert_changekeywords_btn();
      $(this).tooltip('hide');
      $('#limit-keywords-data').text('20件');
      $('#limit-data-num').val(20);
      $('#modalSendmailExecute').prop('disabled', true);
      $('.dropdown-menu.show:last').closest('.action-close-dropdown').find('.dropdown-toggle').click();
  });
 
  $('#limit-keywords-data-tooltip').on('show.bs.dropdown', function(){
      $(this).tooltip('disable');
  });
  $('#limit-keywords-data-tooltip').on('hide.bs.dropdown', function(){
      $(this).tooltip('enable');
  });
  $('#limit-data-num option').on('click', function(){
      $('#limit-keywords-data').text($(this).val() + '件');
  });

  $('#keywords-list').on('click', function() {
      var check_letters = $('#modalSendmailBodyTitle').val() + $('#modalSendmailBodyText').val();
      check_presence_keyword(check_letters);
  });

  var buttons_as_disabled = $('.list-tooltip-as-disabled');
  function check_presence_keyword(letters) {
      $.each(buttons_as_disabled, function(){
          var tooltip_selector = $(this);
          var target_selector = tooltip_selector.find('button');
          var class_name = target_selector.attr('class');
          if(letters.indexOf(target_selector.val()) != -1){
              class_name = class_name.replace(/btn-outline-dark2/, 'btn-outline-secondary');
              target_selector.prop('disabled', true).attr({
                  'class': class_name,
                   'style': 'pointer-events:none;border-color:#a8b7c5;'
              });
              tooltip_selector.tooltip('enable');
          }else{
              class_name = class_name.replace(/btn-outline-secondary/, 'btn-outline-dark2');
              target_selector.prop('disabled', false).attr('class', class_name).removeAttr('style');
              tooltip_selector.tooltip('disable');
          }
      });
  }
  function check_mail_length(letters){
      var count_bytes = calc_bytes(letters);
      count_bytes > 1 ? $('#show-byte').text('bytes') : $('#show-byte').text('byte');
      $('#count-letters').text(count_bytes.toLocaleString());
      if(count_bytes > 1048576){
          $('#mail-length-over').attr('class', 'visible');
      }else{
          $('#mail-length-over').attr('class', 'invisible');
      }
  }
  function calc_bytes(letters){
      var bytes = encodeURIComponent(letters).replace(/%../g,"x").length;
      return bytes;
  }
   
  if (JSON.parse($('#pages_checked').val()).length > 0){
      $('.bulkbtns').removeClass('disabled');
      $('.bulkbtns').prop('disabled', false);
  }

 
  //sticky_control('SummaryTable');
                
    // sticky controll
  /*  (function() {
	window.onscroll = function() { stickyAdd(); };
  var ActionArea = document.getElementById("wrap-ActionArea");
	var SummaryT     = document.getElementById('SummaryTable');
  $('#ActionArea').css('margin-left','0');
  const footer = $('footer');
	function stickyAdd() {
	    var SummaryTdynamic = SummaryT.offsetTop;
	    var SummaryTHeight= document.getElementById('SummaryTable').clientHeight;
	    var SummaryOffset = SummaryTdynamic + SummaryTHeight;
	    if (window.pageYOffset >= SummaryOffset) {
      $(ActionArea).append(footer);
      $('#hidden-space').height($('#wrap-ActionArea').height());
		ActionArea.classList.add('sticky');
	    } else {
    $('#hidden-space').height('0');
    $(ActionArea).find('footer').remove();
		ActionArea.classList.remove('sticky');
	    }
	    console.log( "SummaryTdynamic: " + SummaryTdynamic + "\n" ) ;
              console.log( "SummaryTHeight: " + SummaryTHeight + "\n" ) ;
              console.log( "SummaryOffset: " + SummaryOffset + "\n" ) ;
              console.log( "window.pageYOffset: " + window.pageYOffset + "\n" ) ;
	       
	}
    })();*/
  sticky_control('SummaryTable', 'hosts');

  $(window).on('load', function() { 
      setTimeout(function(){
          set_scroll();
          $(window).on('resize scroll', set_scroll);  
      },200);
      $('.modal').on('show.bs.modal', function(){
          $('#floating-scroll').css('z-index', '10');
      });
      $('.modal').on('hidden.bs.modal', function(){
          $('#floating-scroll').css('z-index', '1060');
      });

  });  
  
  //ブラウザバックだったらチェックボックスの表示を修正
  $.post($('#check_browser_back_path').val(), {'page_name': 'hosts'},
      function(info){
          if(info === 'browser_back'){
              var is_all_checked = $('#pages_all_checked').val();
              if(is_all_checked === 'true'){
                  var all_ids = JSON.parse($('#all_host_ids').val());
                  $('#Sort-TR').find('#allSelect, .hostSelect').prop('checked', true);
                  $('#pages_checked').val(JSON.stringify(all_ids.filter(Boolean)));
              }else{
                  $('#SortTR').find('#allSelect, .hostSelect').prop('checked', false);
                  var pages_checked = JSON.parse($('#pages_checked').val());
                  var target_elm = '';
                  for (var id of pages_checked){
                      target_elm += '#table_selected' + id + ',';
                  }
                  target_elm = target_elm.slice(0, -1);
                  $(target_elm).prop('checked', true);
              }
          }
   });   
   //担当者にメール送信画面で、ホスト名とカテゴリ名を表示した時にpopoverを表示する（bootstrapのpopoverだとバグになるので独自に実装
    $(document).on('click', '.show-original-popover', function(){
        var button = $(this);
        var id = button.attr('data-popoverid');
        var popover = $('.original-popover');
        var popover_id = popover.attr('data-popoverid');
        popover.remove();
        if(popover_id === id){
            return false;
        }
        var content = $('<div>').attr({
                                'class': 'original-popover',
                                'data-popoverid': id,
                                });
        var inner_content = $('<div>').attr('class', 'original-popover-inner');
        var text = button.attr('data-content');
        button.attr('data-html') ? inner_content.html(text) : inner_content.text(text);
        content.append(inner_content);
        var triangle_target = $('<div>').attr({
                                         'class': 'position-relative triangle',
                                         'data-popoverid': id,
                                        });
        content.append(triangle_target);
        content.css('opacity', 0);
        $('body').append(content);
        var btn_width = button.outerWidth(true);
        var content_width = content.outerWidth(true);
        var offset = button.offset();
        var offset_top = offset.top - content.outerHeight(true) - 5;
        var offset_left = offset.left + (btn_width / 2) - (content_width / 2);
        content.offset({
            'top': offset_top,
            'left': offset_left
        });
        content.css({
            'opacity': ''
        });
    });

    //担当者にメール送信を開いている時に画面クリックでpopover削除
    $('#modalSendMail').on('click', function(e){
        if(e.target){
            var t_elm = $(e.target);
            if(!t_elm.hasClass('show-original-popover') && t_elm.closest('.show-original-popover').length === 0 && !t_elm.hasClass('triangle')){
                $('.original-popover').remove();
            }
        }
    });
    
    //担当者にメール送信画面のスクロールでpopover削除
    $('.modal-mail-table').on('scroll', function(){
        $('.original-popover').remove();
    });
  
    //画面のリサイズでpopover削除
    $(window).on('resize', function(){
        $('.original-popover').remove();
    });
    
});
